/** Xelfi class containing the main function
* @author: Filip Dvorak
* @version: 1.0
*/

package xelfi;

import java.awt.Window;
import xelfi.top.TopLevel;
import xelfi.top.XelfiLogo;
import xelfi.top.XelfiLogo95;
import xelfi.util.Debug;

public class Xelfi
{
  public static final int CONFIG = 0;

  public static void main(String args[])
  {
    Debug.setDebugging(true);
    boolean logo95;
    Window xlogo;
    if(TopLevel.getOS() == TopLevel.OS_WINDOWS95 || TopLevel.getOS() == TopLevel.OS_WINDOWSNT ||
      TopLevel.getOS() == TopLevel.OS_OS2) logo95 = true;
    else logo95 = false;
    if(logo95)
    {
      try
      {
        (xlogo = new XelfiLogo95()).show();
      }
      catch(Exception e) // if there is a problem starting window logo then start standard logo
      {
        (xlogo = new XelfiLogo()).show();
      }
    }
    else (xlogo = new XelfiLogo()).show();

   Object options[] = new Object[1];
    int i = 0, length = args.length;

      // let's go through the command line
    for(i = 0; i < length; i++)
    {
      if(args[i].equalsIgnoreCase("-cfg"))
      {
        try
        {
          options[CONFIG] = args[++i];
        }
        catch(ArrayIndexOutOfBoundsException e)
        {
          System.err.println("Config file name expected, using default.");
        }
      }
      else
      {
        System.err.print("Unknown option ");
        System.err.println(args[i]);
      }
    }

    TopLevel.init(options);
   xlogo.hide();
  }
}

