
package xelfi.browser.document;

import java.util.*;
import java.io.*;
import xelfi.editor.EndOfTextException;

import xelfi.browser.view.BrowserSettings;

/**
* Class containing static methods managing instances of BrComponent
* subclasses.
* Methods: parse  is used, when user firstly look on package, file or dir
*          reparse is used, when user save file, or click on reparse button
*
* @version $Id$
* @autor Jan Jancura
*/
public class ComponentManager implements xelfi.editor.EditorLoader
{

    private static BrUsers          users;
    private static BrUser           user;
    private static BrProject        project;

    static public Hashtable         hash        = new Hashtable(100);
    //static public Vector            allForms    = new Vector(10,20);


    public static BrUsers Init(String usersPath)
    {
        // zaregistruji XFile
        xelfi.editor.Editor.setSourceFinder(new XFile());
        // zaregistruji EditorLoader
        xelfi.editor.Editor.addLoader(new ComponentManager());
        // detekujeme vsechny uzivatele
        return (users = new BrUsers(usersPath));
    }
    public static void destroy()
    {
        users.save();
        return;
    }

    /** Returns all users.
    * @return All users.
    */
    public static BrUsers getUsers()
    {
        return users;
    }
    public static BrUser getLoggedUser()
    {
        return user;
    }
    public static BrProject getOpenedProject()
    {
        return project;
    }
    public static BrUser logInUser(BrUser pUser)
    {
        user = pUser;
        return user;
    }
    public static BrProject openProject(BrProject pProject)
    {
        if( project != null )
        {
            //zavrit stary
        }
        project = pProject;
        // otevrit novy
        return project;
    }






    // Prace s package, a adr..
    //  pouziva to Parser a PackageView
    public static boolean isParsedDir(String pDir)
    {
        return hash.containsKey(pDir);
    }
    public static Vector getParsedDir(String pDir)
    {
        return (Vector)hash.get(pDir);
    }
    public static void removeDir(String pDir)
    {
        //System.out.println("removeDir");
        hash.remove(pDir);
        return;
    }
    public static Vector parseDir(String pDir,int prj)
        throws FileNotFoundException
    {// pokud dir neexistuje vraci null

        // Neni uz nahodou naparsovany???
        if( isParsedDir(pDir) )
        {
            Vector v = getParsedDir(pDir);
            int i,k = v.size();
            for(i=0;i<k;i++)
                ((BrPackage)v.elementAt(i)).setProject(prj);
            return v;
        }
        // natahovani z disku...
        Vector v = Parser.reparseDir(pDir,prj);
        hash.put(pDir,v);
        return v;
    }
    public static Vector reparseDir(String pDir,int prj)
        throws FileNotFoundException
    {// pokud dir neexistuje vraci null

        hash.remove(pDir);
        Vector v = Parser.reparseDir(pDir,prj);
        hash.put(pDir,v);
        return v;
    }




    /** Return package.
    * @file Expect dir and package name for this procedure.
    * @parse If dir isn't parsed yet, parse it.
    * @exception FileNotFoundException if package isn't found in disk
    */
    public static BrPackage getPackage(XFile file,boolean parse)
        throws FileNotFoundException
    {
        return getPackage(file.getPathStr(),file.getPackage(),parse);
    }
    /** Return package, if it exists.
    * @param path Path from which package is excluded.
    * @param packageName Name of package.
    * @param parse If true than path of this package will be parsed if isn't.
    * @exception FileNotFoundException if package isn't found in disk
    */
    public static BrPackage getPackage(String path,
        String packageName,boolean parse) throws FileNotFoundException
    { // vraci package dle cesty a jmena

        //System.out.println("getPackage "+ path);
        Vector v = (Vector)hash.get(path);
        if( v == null )
        {
            if( !parse ) return null;
            v = parseDir(path,0);
        }
        //System.out.println("getPackage nalezena cesta "+ path);

        int i,k = v.size();
        //System.out.println("getPackage  "+ packageName+" "+ k);
        BrPackage pom;
        packageName = packageName.trim();
        for(i=0;i<k;i++)
            if( (pom = (BrPackage)v.elementAt(i)).getXFile().
                getPackage().trim().
                equals(packageName) ) return pom;
        throw new FileNotFoundException();
    }

    /** Parse the package if dir is already parsed.
    * @param pkg package
    * @exception FileNotFoundException if package isn't found in disk
    * @exception IOException if IOErroc occures
    */
    public static void parsePackage(BrPackage pkg)
        throws FileNotFoundException,IOException
    {// naparsuje package
    //
        if( pkg == null )
        {
            System.out.println("Error n.1209 in ComponentManager" +
                ".parsePackage");
            return;
        }

        pkg.removeObjects();

        File f = new File(pkg.getXFile().getFile(),pkg.getXFile().
            getPackage() + ".brw");
        if( !f.exists() || !f.canRead() )
        {
            // natahovani z disku
            Parser p = new Parser(pkg);
            //Parser.reparsePackage(pkg);
            return;
        }
        DataInputStream is = new DataInputStream(new FileInputStream(f));
        int ch;
        BrObject o = null;
        while( (ch = is.readByte()) != 'e' )
        {
            switch( ch )
            {
            case 'i':
                pkg.addComponent(o = new BrInterface(pkg,is));
                break;
            case 'f':
                pkg.addComponent(o = new BrClass(pkg,is,true));
                break;
            case 'c':
                pkg.addComponent(o = new BrClass(pkg,is,false));
                break;
            case 'm':
                o.addComponent(new BrMethod(o,is));
                break;
            case 'v':
                o.addComponent(new BrVariable(o,is));
                break;
            }
        }
        return;
    }
    public static void reparsePackage(BrPackage pkg)
        throws FileNotFoundException,IOException
    {
        if( pkg == null )
        {
            System.out.println("Error n.1208 in ComponentManager" +
                ".parsePackage");
            return;
        }
        pkg.removeObjects();
        Parser p = new Parser(pkg);
        //Parser.reparsePackage(pkg);
        return;
    }
    static void reparseTimer()
    {
        BrowserSettings.repaint(3);
    }
    // dodelej !!!
    static public int movePackage(BrPackage oldP,BrPackage newP,
        boolean chPkg,boolean chImp)
    {   // Prenasi package. zjisti, existuje li jiz.
        // zkopiruje soubory ... pokud neexistoval,
        // vytvori i novy BrPackage a da do hash!!!
        for(Enumeration e = oldP.getAllObjects();
                e.hasMoreElements();)
            newP.addComponent((BrComponent)e.nextElement());
        return 1;
    }
    /**
     * This method adds new package
     * @param BrPackage c Package to add.
     * @return int Return 0 if no error occurred. If package already
     * exists returns 2 and if this path isn't scanned still, returns 1.
     * If directory cann't be created (user hasn't access) returns 3;
     */
    static public int addPackage(BrPackage c)
    {   //prida package (dir) a BrPackage!
        if( hash.containsKey(c.getXFile().getPathStr()) )
        {
            //System.out.println("addPackage contain");
            Vector v = (Vector)hash.get(c.getXFile().getPathStr());
            BrPackage p;
            int i,k = v.size();
            for(i=0;i<k;i++)
            {
                p = (BrPackage)v.elementAt(i);
                if( p.name.equals(c.name) )
                    break;
            }
            if( i != k )
            {
                return 2;//Package already exists
            }
            if( !c.getXFile().getFile().mkdirs() )
            {
                return 3;
            }
            v.addElement(c);
            return 0;
        }else
        {   //v hash tab. c neni!!
            return 1;
        }
    }
    /**
     * This method deletes package (last dir from path) with
     * this contents on the disk and in memory.
     * @param BrPackage p Package to delete.
     * @return int 0 if it's OK. If some file cann't be deleted returns 1,
     *  if directory cann't be deleted returns 2, if path of package isn't
     * parsed still returns 3 and if package don't exists returns 4.
     */
    public static int deletePackage(BrPackage p)
    {   // move files and path to kos
        Vector v = getParsedDir(p.getXFile().getPathStr());
        if( v == null )
            return 3;
        if( !v.contains(p) )
            return 4;
        v.removeElement(p);
        String path = p.getXFile().getFileName();
        String[] ss = (new File(path)).list();
        int i,k = ss.length;
        System.gc();
        System.runFinalization();
        Runtime.getRuntime().gc();
        Runtime.getRuntime().runFinalization();
        for(i=0;i<k;i++)
        {
            if( !(new File(path + ss[i])).delete() )
                return 1;
        }
        System.gc();
        System.runFinalization();
        Runtime.getRuntime().gc();
        Runtime.getRuntime().runFinalization();
        if( !(new File(path)).delete() )
            return 2;
        return 1;
    }




    // prace s objekty a membry....

    /** Reparse file. If package isn't reparsed, reparse dir too.
    * @exception FileNotFoundException if package file isn't found in disk
    * @exception IOException if IOError occures
    */
    public static void parseFile(XFile file)
        throws FileNotFoundException,IOException
    {
        //System.out.println("CM.reparseFile "+file);
        BrPackage p = getPackage(file,true);
        //System.out.println("CM.reparseFile1 ");
        // existoval? -> musim zrusit...
        p.removeObject(file.getName());

        Parser.reparseSources();
        //!!! parse
        Parser.reparseFile(p,file,Parser.isForm(file));
        return;
    }
    /** Reparse file. If package isn't reparsed, reparse dir too.
    * @exception FileNotFoundException if package file isn't found in disk
    * @exception IOException if IOError occures
    */
    public static void reparseFile(XFile file)
        throws FileNotFoundException,IOException
    {
        BrPackage p = getPackage(file,true);
        Vector v = getObjectsFromFile(file,false);
        int i,k = v.size();
        for(i=0;i<k;i++)
            p.removeObject((BrObject)v.elementAt(i));
        Parser.reparseSources();
        Parser.reparseFile(p,file,Parser.isForm(file));
        return;
    }

    /** Returns object.
    * @exception FileNotFoundException if package file isn't found in disk
    * @exception IOException if IOError occures
    */
    public static BrObject getObject(XFile file,boolean parse)
        throws FileNotFoundException,IOException
    {
        BrPackage p = getPackage(file,parse);
        if( p == null ) return null;
        //!!! parse
        BrObject o = p.getObject(file.getName());
        if( o == null )
        {
            if( parse  ) return null;
            Parser.reparseSources();
            Parser.reparsePackage(p);
            o = p.getObject(file.getName());
            if( o == null )
            {
                System.out.println("Error n.1208 in ComponentManager" +
                    ".getObject");
                return null;
            }
        }
        return o;
    }


    public static Enumeration getObjectsFromPackage(XFile dir,
        boolean parse) throws FileNotFoundException,IOException
    {
        //System.out.println("getObjectsFromPackage ");
        BrPackage p = getPackage(dir,parse);
        if( p == null ) return null;
        //System.out.println("getObjectsFromPackage :" +
          //  p.name);
        Enumeration e = p.getAllObjects();
        if( e.hasMoreElements() )
            return e;
        parsePackage(p);
        return p.getAllObjects();
    }
    public static Vector getObjectsFromFile(XFile file,boolean parse)
         throws FileNotFoundException,IOException
    {
        Enumeration e = getObjectsFromPackage(file,parse);
        if( (e == null) || !e.hasMoreElements() )
        {
            //System.out.println("neexistujici package!!!");
            return null;
        }
        Vector v = new Vector(5,5);
        BrObject o;
        for(;e.hasMoreElements();)
            if( (o = (BrObject)e.nextElement()).getXFile().
                    equals(file) )
                v.addElement(o);
        return v;
    }



    // implementace EditorLoaderu

    private ComponentManager()
    {
    }

    /** This method is called when a new document is loaded into memory.
    * @param s the source object of the class
    */
    public void newDocumentHasBeenLoaded (xelfi.editor.Source s)
    {
        //System.out.println("Loading :" + s.getFile());
        Vector v = null;
        try
        {
            v = getObjectsFromFile((XFile)s.getFile(),true);
        }catch(FileNotFoundException e)
        {
            System.out.println("FileNotFoundException "+e);
        }catch(IOException e)
        {
            System.out.println("IOException "+e);
        }

        if( v == null ) return;
        int i,k = v.size();
        try{
            for(i=0;i<k;i++)
                ((BrObject)v.elementAt(i)).fileIsOpened(s.getDocument());
        }catch(EndOfTextException e)
        {
            System.out.println("EndOfTextException in ComponentMan");
        }
        //System.out.println("Loading end...");
        return;
    }

    /** This method is called when an old document is about to close.
    * @param s the source object of the class
    * @warning the source object s will became invalid after finishing this
    * method. So <EM>do not store pointer to it anywhere!</EM>
    * If you do not want to relase the document from memory create new
    * Source object for class s.getName ().
    * But again <EM>do not use the s object itself</EM>.
    */
    public void documentIsAboutToClose (xelfi.editor.Source s)
    {
        //System.out.println("Closing :" + s.getFile());
        Vector v = null;
        try
        {
            v = getObjectsFromFile((XFile)s.getFile(),true);
        }catch(FileNotFoundException e)
        {
            System.out.println("FileNotFoundException "+e);
        }catch(IOException e)
        {
            System.out.println("IOException "+e);
        }

        int i,k = v.size();
        for(i=0;i<k;i++)
            ((BrObject)v.elementAt(i)).fileIsClosed();
        return;
    }

    public static BrPackage[] getSelectedPackages()
    {
        return (BrPackage[])(BrowserSettings.getSelectedComponents(2));
    }
    public static BrObject[] getSelectedObject()
    {
        return (BrObject[])(BrowserSettings.getSelectedComponents(3));
    }
    public static BrMember[] getSelectedMember()
    {
        return (BrMember[])(BrowserSettings.getSelectedComponents(4));
    }

    /*public static void deleteObject(BrObject o)
    {
        return;
    }
    public static void addObject(BrObject o)
    {
        return;
    }*/
    public static void setAsMain(BrObject o)
    {
        return;
    }

    // Vracene tridy nemusi existovat, ale daji se spristupnit pres
      //  BrObject.getXFile()  (trida ve tride)
    // is this instanceOf BrClass && this.isForm()  <==> je to form
    // a musi se otvirat specielne.


}























