
package xelfi.browser.view;

import java.awt.*;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Vector;
//import java.lang.ArrayOutOfBoundsException;

import xelfi.browser.document.*;
//import xelfi.util.*;
import xelfi.browser.util.*;
import xelfi.awt.PageControl;

public class BrowserPanel extends Panel
{
    // Graphics components
    private Choice          chMode;
    private List[]          list;
    private Checkbox        chPkgProject;
    private Checkbox        chPkgSystem;
    private Checkbox        chObjClass;
    private Checkbox        chObjInterface;
    private Checkbox        chMemVariable;
    private Checkbox        chMemMethod;

    // Non visual variables
    BrSettings              settings;

    private BrComponent[]   choiceObj;
    private BrComponent[][] listsObj;
    private BrComponent[]   rootObj;

    private int[]           numOfSelected; // Number of selected
                                           // Obj in list[]
    private Vector[]        selItems;      // Vector of selected
                                           // Obj in list[]
    private BrComponent     lastChanged;   // last selected/desel.
                                           // Obj.Usefull for OpenView
    private int             lastSelect;    // same as lastChanged
                                           // but number. Used in OpenView
    private boolean[]       sort;

    private int[]           depth;         // pomocna pr. uchovava hloubku
                                           // componenty pri hierarched
    boolean[]               hierarched;
    boolean                 sortCh;


    BrowserPanel(BrSettings set)
    {
        //System.out.println("BP");
        settings = new BrSettings(set);
        if( (settings.Mode + settings.Columns) > 5 )
            settings.Columns = 5 - settings.Mode;
        BrComponent associated = initContents();
        initNext(associated);
        return;
    }
    private void initNext(BrComponent associated)
    {
        //System.out.println("initNext");
        initMembers();
        initGraphics();
        if( settings.Choice && (settings.Mode != 0) )
            refill(-1);

        if( associated != null )
        {
            chMode.select(associated.name);
        }
        refill(0);
        //System.out.println("initNext end");
        return;
    }

    /**
     * This method initialize variables :
     *   rootObj[], associated
     * dependently on value of variable settings,
     * and can change settings.Mode
     */
    private BrComponent initContents()
    {// vola se pokud nechceme asociovat

        //System.out.println("initContents");
        int begin = Math.max(settings.Mode -
            (settings.Choice?1:0),0);
        BrUser user = ComponentManager.getLoggedUser();
        BrProject project = ComponentManager.getOpenedProject();


        // initial selection
        BrComponent associated = null;
        rootObj = new BrComponent[1];
        rootObj[0] = ComponentManager.getUsers();

        if( settings.Choice && (user != null) )
        {
            associated = user;
        }
        // END initial selection

        if( (begin == 1) && (user != null) )
        {
            rootObj[0] = user;
            if( settings.Choice && (project != null) )
                associated = project;
        }else
        if( (begin == 2) && (project != null) )
        {
            rootObj[0] = project;
            // vylistovat project home
        }else
        if( (begin > 2) && (project != null) )
        {// jsem mimo
            if( settings.Choice )
            {
                rootObj[0] = user;
                associated = project;
            }else
                rootObj[0] = project;

            settings.Mode = 2;
            begin = 2 - (settings.Choice?1:0);
        }

        //System.out.println("initContents end");

        return associated;
    }
    BrowserPanel(BrSettings set,BrowserPanel old)
    {
        //System.out.println("BP");

        settings = new BrSettings(set);
        if( (settings.Mode + settings.Columns) > 5 )
            settings.Columns = 5 - settings.Mode;
        BrSettings oldSet = old.getSettings();
        BrComponent associated = null;

        // hledani rootObj !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        int oldBegin = Math.max(oldSet.Mode - (oldSet.Choice?1:0),0);
        int newBegin = Math.max(settings.Mode - (settings.Choice?1:0),0);
        if( oldBegin == newBegin )
        {
            rootObj = old.rootObj;
            //initSelItems(old,0);
            //if( settings.Choice ) associated = old.associated;
            //System.out.println("Test = ");
        }else
        if( (oldBegin < newBegin) &&
            ((oldSet.Mode + oldSet.Columns + 1) >= newBegin) )

        { // in
            //System.out.println("Change panel in");
            int index = newBegin - 1 - oldSet.Mode;
            if( index == -1 )
            { // jsem v Choice
                //System.out.println("Change panel in Choice ");
                int pomI = old.chMode.getSelectedIndex()-6;
                if( pomI >= 0 )
                {
                    rootObj = new BrComponent[1];
                    rootObj[0] = old.choiceObj[pomI];
                    //initSelItems(old,newBegin - oldBegin);
                    //System.out.println("Test in 2");
                }else
                {   //neni vybrano
                    associated = initContents();
                    initNext(associated);
                    //System.out.println("Test in out 2");
                    return;
                }
            }else   //jsem v listboxech
            {
                //System.out.println("Change panel in listboxech " + index);
                int[] ind = old.list[index].getSelectedIndexes();
                int l = ind.length;
                if( l > 0 )
                {
                    rootObj = new BrComponent[ind.length];
                    for(int i=0;i<ind.length;i++)
                    {
                        rootObj[i] = old.listsObj[index][ind[i]];
                    }
                    //initSelItems(old,newBegin - oldBegin);
                    //System.out.println("Test in ");
                }else
                { //neni vybrano
                    associated = initContents();
                    initNext(associated);
                    //System.out.println("Test in out ");
                    return;
                }
            }
        }else // konec in
        { // out  jsem mimo nemohu asociovat !!!
            associated = initContents();
            initNext(associated);
            //System.out.println("Test out ");
            return;
        }

        //System.out.println("initMembers");
        initMembers();
        //System.out.println("initGraphics");
        initGraphics();
        //System.out.println("refill");

// naplneni urovne 1 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        if( settings.Choice && (settings.Mode != 0) )
            refill(-1);

// nastaveni selItems a associated !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        int pos = newBegin - oldBegin;
        //System.out.println("initSelItems ");
        int i = 0;
        int pomO;
        if( settings.Choice )
        {
            // fill Choice
            if( old.settings.Choice )
            {
                if( pos == 0 )
                {
                    //System.out.println("pom1 ");
                    if( (pomO = (old.chMode.
                        getSelectedIndex())) != -1 )
                        chMode.select(pomO);
                    //System.out.println("pom2 ");
                }else
                {
                    if( old.selItems[pos - 1].size() > 0 )
                        chMode.select(((BrComponent)old.selItems
                            [pos - 1].firstElement()).name);
                }
            }else
            {
                if( old.selItems[pos].size() > 0 )
                    chMode.select(((BrComponent)old.selItems
                        [pos].firstElement()).name);
            }
            if( !oldSet.Choice )
                pos++;
            pomO = Math.min(oldSet.Columns,settings.Columns);
            for(;(i+pos)<pomO;i++)
            {
                selItems[i] = old.selItems[i + pos];
            }
        }else
        {// neni choice
            if( oldSet.Choice )
            {
                if( pos == 0 )
                {
                    if( (pomO = old.chMode.
                        getSelectedIndex()) > 5 )
                    {
                        selItems[0].addElement(
                            old.choiceObj[pomO - 6]);
                    }
                    i = 1;
                }
                pos--;
            }
            pomO = Math.min(oldSet.Columns,settings.Columns);
            for(;(i+pos)<pomO;i++)
            {
                selItems[i] = old.selItems[i + pos];
            }
        }

        //System.out.println("initSelItems end");
        refill(0);
        return;
    }
    void setRoot(BrComponent[] comp)
    {
        rootObj = comp;
        return;
    }

    /**
     * This method initialize variables :
     *   listsObj[], numOfSelected[], selItems[], sort[], sortCh
     *   and hierarched[]
     * dependently on value of variable settings.
     */
    private void initMembers()
    {
        //System.out.println("initMembers ");
        listsObj = new BrComponent[settings.Columns][];
        numOfSelected = new int[settings.Columns];

        selItems = new Vector[settings.Columns];
        for(int i=0;i<settings.Columns;i++)
            selItems[i] = new Vector(50,20);

        // init sort, sortCh
        int i,k = settings.Columns;
        sort = new boolean[k];
        for(i=0;i<k;i++)
            sort[i] = false;
        if( settings.ObjSort > 0 )
        {
            if( (settings.Mode <= 3) &&
                ((settings.Mode + settings.Columns) > 3) )
                    sort[3 - settings.Mode] = true;
            else
            if( (settings.Mode == 4) &&
                settings.Choice ) sortCh = true;
            else
                sortCh = false;
        }
        if( (settings.MemSort == 2) &&
            ((settings.Mode + settings.Columns) > 4) )
                    sort[4 - settings.Mode] = true;

        // init hierarched
        k = settings.Columns;
        hierarched = new boolean[k];
        for(i=0;i<k;i++)
            hierarched[i] = false;
        if( settings.ObjSort == 2 )
        {
            if( (settings.Mode <= 3) &&
                ((settings.Mode + settings.Columns) > 3) )
                    hierarched[3 - settings.Mode] = true;
        }

        // init flags
/*        int i,k = settings.Columns;
        flags = new boolean[k];
        for(i=0;i<k;i++)
            flags[i] = false;
        if( settings.ObjShowModif &&
            (settings.Mode<= 3) &&
            ((settings.Mode + settings.Columns) > 3) )
                flags[3 - settings.Mode] = true;
        if( settings.MemShowModif &&
            ((settings.Mode + settings.Columns) > 4) )
                flags[4 - settings.Mode] = true;*/


        //System.out.println("initMembers end");
        return;
    }
    private void initGraphics()
    {
        //System.out.println("initGraphics");
        setBackground(Color.lightGray);

        GridBagLayout l = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        setLayout(l);

  //      w.addNotify();
    //    w.resize(w.insets().left + w.insets().right + 545, w.insets().top + w.insets().bottom + 373);

        c.gridy=0;

        if( settings.Choice )
        {
            c.weightx = 1.0;
            c.weighty = 0.0;
            c.gridwidth = 6;
            c.anchor = GridBagConstraints.EAST;

            Label lab;
            if( settings.Mode != 0 )
              lab = new Label(BrowserSettings.SMode[settings.Mode-1]);
            else
              lab = new Label("Modes:");
            l.setConstraints(lab,c);
            add(lab);

            //c.gridwidth = GridBagConstraints.REMAINDER;
            c.fill = GridBagConstraints.HORIZONTAL;
            c.anchor = GridBagConstraints.CENTER;

            chMode = new Choice();
            l.setConstraints(chMode,c);
            for(int i=0;i<5;i++)
              chMode.addItem(BrowserSettings.SMode[i]);
            chMode.addItem("-------------");
            add(chMode);
            chMode.select(settings.Mode);

            c.gridx=0;
            c.gridy=1;
        }

        c.weightx = 1.0;
        c.weighty = 0.0;
        c.anchor = GridBagConstraints.CENTER;

        c.gridwidth = 12/settings.Columns;

        c.gridy++;
        for(int i=0;i<settings.Columns;i++)
        {

            Label lab=new Label(BrowserSettings.SMode[settings.Mode+i]);
            l.setConstraints(lab,c);
            add(lab);

            c.gridx=GridBagConstraints.RELATIVE;
        }


        list = new List[settings.Columns];
        c.fill = GridBagConstraints.BOTH;
        c.weighty = 1.0;
        c.gridy++;
        for(int i=0;i<settings.Columns;i++)
        {
            list[i] = new List();
            l.setConstraints(list[i],c);
            list[i].setBackground(Color.white);
            list[i].setFont(new Font("Courier",Font.BOLD,11));
            if( settings.MultipleSelectioned )
                list[i].setMultipleSelections(true);
            add(list[i]);
        }

        if( settings.Checkbox )
        {
            c.weighty = 0.0;
            c.gridy++;
            c.gridwidth = 6/settings.Columns;
            int pom=Math.max(0,2-settings.Mode);
            c.gridx=c.gridwidth*pom*2;

            if( (settings.Mode<3)&&((settings.Mode+settings.Columns)>2) )
            {
                chPkgProject = new Checkbox("Project");
                l.setConstraints(chPkgProject,c);
                chPkgProject.setState(settings.PackProject);
                add(chPkgProject);

                c.gridx=GridBagConstraints.RELATIVE;

                chPkgSystem = new Checkbox("System");
                l.setConstraints(chPkgSystem,c);
                chPkgSystem.setState(settings.PackSystem);
                add(chPkgSystem);
            }
            if( (settings.Mode<4)&&((settings.Mode+settings.Columns)>3) )
            {
                chObjClass = new Checkbox("Class");
                l.setConstraints(chObjClass,c);
                chObjClass.setState(settings.ObjClass);
                add(chObjClass);

                c.gridx=GridBagConstraints.RELATIVE;

                chObjInterface = new Checkbox("Interface");
                l.setConstraints(chObjInterface,c);
                chObjInterface.setState(settings.ObjInterface);
                add(chObjInterface);
            }
            if( (settings.Mode<5)&&((settings.Mode+settings.Columns)>4) )
            {
                chMemMethod = new Checkbox("Method");
                l.setConstraints(chMemMethod,c);
                chMemMethod.setState(settings.MemMethod);
                add(chMemMethod);

                c.gridx=GridBagConstraints.RELATIVE;

                chMemVariable = new Checkbox("Variable");
                l.setConstraints(chMemVariable,c);
                chMemVariable.setState(settings.MemVariable);
                add(chMemVariable);
            }
        }
        //System.out.println("initGraphics end");
        return;
    }
    public void initTitle()
    {
        //vyuziva rootObj begin
        // a vraci titulek okna
        int l = rootObj.length;
        String pom = "";
        switch( Math.max(settings.Mode -
            (settings.Choice?1:0),0) )
        {
        case 0: pom = "All users";
                break;
        case 1: if( l > 1 )
                    pom = l + " users";
                else
                    pom = "User " + rootObj[0].name;
                break;
        case 2: if( l > 1 )
                    pom = l + " projects";
                else
                    pom = "Project " + rootObj[0].name;
                break;
        case 3: if( rootObj.length > 1 )
                    pom = l + " packages";
                else
                    pom = "Package " + rootObj[0].name;
                break;
        case 4: if( rootObj.length > 1 )
                    pom = l + " objects";
                else
                    if( rootObj[0] instanceof BrInterface )
                        pom = "Interface " + rootObj[0].name;
                    else
                        pom = "Class " + rootObj[0].name;
        }
        Window w = (Window)getParent();
        if( w instanceof Frame ) ((Frame)w).setTitle(pom);
        else ((Dialog)w).setTitle(pom);
        return;
    }
    public BrSettings getSettings()
    {
        return settings;
    }
    //private void init(BrComponent associated)
    //{
        /*
        System.out.println("Init BP");

        if( settings.Choice && (settings.Mode != 0) )
        {
            refill(-1);
            //choiceObj = getComponents(rootObj);
        }else
            refill(0);
            //listsObj[0] = getComponents(rootObj);//rootObj.getComponents(this);
        //if( settings.Choice && (settings.Mode != 0) )
          //  repaintList(-1);
       // else
         //   repaintList(0);

        if( associated != null )
        {
            if( !settings.Choice ) //System.out.println("Chyba! associated");
            chMode.select(associated.name);
            System.out.println(associated.name);
            refill(0);//listsObj[0] = getComponent(associated);
        }


        //System.out.println("Init BP end");
*/    //}
    BrComponent[] getComponents(BrComponent[] srcComponents,
        boolean pack)
    {
        //System.out.println("getComponents ");
        try{
        if( srcComponents.length == 1 )
        {
            BrComponent[] out = new BrComponent[srcComponents[0].
                getComponentsNumber(settings)];
            srcComponents[0].getComponents(settings,out,0);
            return out;
        }else
        if( pack )
        {
            int j = 0,i,k = srcComponents.length;
            for(i=0;i<k;i++)
                j = Math.max(srcComponents[i].
                    getComponentsNumber(settings),j);
            BrComponent[] out = new BrComponent[j];
            Vector v = new Vector(60,10);
            for(i=0;i<k;i++)
            {
                j = srcComponents[i].getComponents
                    (settings,out,0);
                for(int l=0;l<j;l++)
                    if( !v.contains(out[l]) )
                        v.addElement(out[l]);
            }
            out = new BrComponent[j=v.size()];
            for(i=0;i<j;i++)
                out[i] = (BrComponent)v.elementAt(i);
            return out;
        }else
        {
            int j = 0,i,k = srcComponents.length;
            for(i=0;i<k;i++)
                j += srcComponents[i].getComponentsNumber(settings);
            BrComponent[] out = new BrComponent[j];
            j = 0;
            for(i=0;i<k;i++)
                j = srcComponents[i].getComponents(settings,out,j);
            //System.out.println("getComponents  end");
            return out;
        }
        }catch(FileNotFoundException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"Directory not exists! ",
                "You must reparse directories. ",null,
                modalDialog.OK);
        }catch(IOException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"IO Exception ",
                null,null,
                modalDialog.OK);
        }
        return new BrComponent[0];
    }
    BrComponent[] getComponents(BrComponent[] srcComponents,
        int[] index,boolean pack)
    {
        //System.out.println("getComponents index");
        try{
        if( index.length == 1 )
        {
            BrComponent[] out = new BrComponent[srcComponents[index[0]].
                getComponentsNumber(settings)];
            srcComponents[index[0]].getComponents(settings,out,0);
            //if( sort ) out = (BrComponent[])Sort.sort(out);
            return out;
        }else
        if( pack )
        {
            int j = 0,i,k = index.length;
            for(i=0;i<k;i++)
                j = Math.max(srcComponents[index[i]].
                    getComponentsNumber(settings),j);
            BrComponent[] out = new BrComponent[j];
            Vector v = new Vector(60,10);
            for(i=0;i<k;i++)
            {
                j = srcComponents[index[i]].getComponents
                    (settings,out,0);
                for(int l=0;l<j;l++)
                    if( !v.contains(out[l]) )
                        v.addElement(out[l]);
            }
            out = new BrComponent[j=v.size()];
            for(i=0;i<j;i++)
                out[i] = (BrComponent)v.elementAt(i);
            return out;
        }else
        {
            int j = 0,i,k = index.length;
            for(i=0;i<k;i++)
                j += srcComponents[index[i]].getComponentsNumber(settings);
            BrComponent[] out = new BrComponent[j];
            j = 0;
            for(i=0;i<k;i++)
                j = srcComponents[index[i]].getComponents(settings,out,j);
            //System.out.println("getComponents  end");
            return out;
        }
        }catch(FileNotFoundException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"Directory not exists! ",
                "You must reparse directories. ",null,
                modalDialog.OK);
        }catch(IOException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"IO Exception ",
                null,null,
                modalDialog.OK);
        }

        return new BrComponent[0];
    }
    BrComponent[] getComponent(BrComponent srcComponent)
    {
        //System.out.println("getComponent");
        try{
        BrComponent[] out = new BrComponent[srcComponent.
            getComponentsNumber(settings)];
        srcComponent.getComponents(settings,out,0);
        //System.out.println("getComponent end");
        return out;
        }catch(FileNotFoundException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"Directory not exists! ",
                "You must reparse directories. ",null,
                modalDialog.OK);
        }catch(IOException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"IO Exception ",
                null,null,
                modalDialog.OK);
        }

        return new BrComponent[0];
    }
/*    BrComponent[] addComponent(BrComponent srcComponent,
                                BrComponent[] old)
    // mezi komponenty old chci pridat potomky komponenty src
    {
        int k = old.length;
        BrComponent[] out = new BrComponent[srcComponent.
            getComponentsNumber(this) + k];
        for(int i=0;i<k;i++) out[i] = old[i];
        srcComponent.getComponents(this,out,k);
        return out;
    }*/
    void refill(int num)// -1 choice 0-2 list 0-2
    {
        if( num >= settings.Columns ) return;

        //System.out.println("refill " + num);
        boolean pack = false;
        if( (settings.Mode + num) == 2 ) pack = true;
        if( num == -1 )
        {
            choiceObj = getComponents(rootObj,pack);
            if( sortCh )
                choiceObj = (BrComponent[])Sort.sort(choiceObj);
            repaintList(num);
            //System.out.println("refill end");
            return;
        }else
        if( num == 0 )
        {
            if( settings.Choice && (settings.Mode != 0) )
            {
                int p = chMode.getSelectedIndex()-6;
                //System.out.println("refill" + p);
                if( p >= 0 )
                    listsObj[0] = getComponent(choiceObj[p]);
                else
                    listsObj[0] = new BrComponent[0];
            }else
                listsObj[0] = getComponents(rootObj,pack);
        }else
        {
            listsObj[num] = getComponents(listsObj[num-1],
                list[num-1].getSelectedIndexes(),pack);
        }
        if( sort[num] )
            listsObj[num] = (BrComponent[])Sort.sort(listsObj[num]);
        if( hierarched[num] )
        {
            depth = Sort.hierarchy((Member[])listsObj[num]);
        }
        repaintList(num);
        //System.out.println("refill end");

        // obnovuji vyber radku...
        int i,j = 0,k = (listsObj[num]==null)?0:listsObj[num].length;
        for(i=0;i<k;i++)
            if( selItems[num].contains(listsObj[num][i]) )
            {
                list[num].select(i);
                j++;
            }

        numOfSelected[num] = j;

        if( (num + 1) < settings.Columns ) refill(num + 1);

        //System.out.println("refill end");
        return;
    }
    void repaintList(int num)
    {
        //System.out.println("repaintList");
        if( num == -1 )
        {
            int j=choiceObj.length;
            //System.out.println("ck: "+j);
            for(int i=0;i<j;i++)
                chMode.addItem(choiceObj[i].name);
        }else
        {
            list[num].clear();
            int j=listsObj[num].length;
            //System.out.println("ck: "+j);

            for(int i=0;i<j;i++)
            {
                list[num].addItem(listsObj[num][i].
                    getFullName(settings,hierarched[num] ?
                        depth[i] : 0));

                    //ffllaaggss
            }
        }
        //System.out.println("repaintList end");
    }
    void OpenView(int num,Event e)
    {
        if( lastSelect != -1 )
            list[num].deselect(lastSelect);
        if( lastChanged instanceof BrObject )
            ObjectView.textEditor((BrObject)lastChanged);
        else
        if( lastChanged instanceof BrMember )
            MemberView.textEditor((BrMember)lastChanged);
        else
            lastChanged.openView(BrowserSettings.mainWindow);
        return;
    }
    void ListDeselect(int num,Event e)
    {
        if( num >= settings.Columns ) return;
        int i;
        //System.out.println("List deselect");
        if( !settings.MultipleSelectioned )
        {
           /* i = ((Integer)e.arg).intValue();
            try{
                lastChanged = listsObj[num][i];
            }catch(ArrayIndexOutOfBoundsException o)
            {
                System.out.println("List deselect nnn");
                return;
            } System.out.println("List deselect 1");
            //BrowserSettings.lastSelected = lastChanged;
            lastSelect = i;
            for(i=num+1;i<settings.Columns;i++)
            {
                listsObj[i+1] = new BrComponent[0];
                repaintList(i);
            }*/
            return;
        }else
        {
            //selItems[num] = list[num].getSelectedItems();
            if( list[num].getSelectedItems().length ==
                numOfSelected[num] )
            {
                //System.out.println("JoJoJo");
                return;
            }else
                refill(num + 1);
            i = ((Integer)e.arg).intValue();
            try{
                lastChanged = listsObj[num][i];
            }catch(ArrayIndexOutOfBoundsException o)
            {
                //System.out.println("List deselect nnn");
                return;
            }
            //BrowserSettings.lastSelected = lastChanged;
            lastSelect = i;
            selItems[num].removeElement(lastChanged);
            numOfSelected[num]--;
            return;
        }
    }
    void ListSelect(int num,Event e)
    {
        if( num >= settings.Columns ) return;
        //System.out.println("List select");
        int i;
        if( !settings.MultipleSelectioned )
        {
            try{
                lastChanged = listsObj[num][list[num].getSelectedIndex()];
            }catch(ArrayIndexOutOfBoundsException o)
            {
                //System.out.println("List select nnn");
                return;
            }
            BrowserSettings.lastSelected = lastChanged;
            if( selItems[num].size() > 0 )
                selItems[num].setElementAt(lastChanged,0);
            else
                selItems[num].addElement(lastChanged);
            lastSelect = -1;
            refill(num + 1);
        }else
        {
            //System.out.println("bbbbb" + e.evt);
            /*if( settings.ShAlt )
            {
                System.out.println(e.modifiers+ "  " + e.key);

                if( e.shiftDown() )
                {
                    System.out.println("SHIFT");
                    int[] pomI = list[num].getSelectedIndexes();
                    int k = pomI.length,i;
                    for(i=pomI[0];i<=pomI[k-1];i++)
                        list[num].select(i);

                }else
                if( e.controlDown() )
                {
                    System.out.println("NORMAL");
                    int k=list[num].countItems(),i;
                    for(i=0;i<k;i++)
                        list[num].deselect(i);
                    list[num].select(((Integer)e.arg).intValue());
                }
            }*/
            int pom = ((Integer)e.arg).intValue();
            try{
                lastChanged = listsObj[num][pom];
            }catch(ArrayIndexOutOfBoundsException o)
            {
                //System.out.println("List select nnn");
                return;
            }
            lastSelect = -1;
            if( !listsObj[num][pom].selectable() )
            {   //vybiram oddelovac
                lastSelect = pom;
                list[num].deselect(pom);
            }else
            {
                //selItems[num] = list[num].getSelectedItems();
                if( list[num].getSelectedItems().length ==
                    numOfSelected[num] )
                {
                    //System.out.println("JoJoJo");
                    return;
                }else
                    refill(num + 1);
                BrowserSettings.lastSelected = lastChanged;
                selItems[num].addElement(lastChanged);
                numOfSelected[num]++;
            }
        }
        //System.out.println("List select end");
        return;
    }
    public boolean handleEvent(Event e)
    {
        //System.out.println("Event"+ e);
        int i;
        if( e.id == Event.ACTION_EVENT )
        {
        //System.out.println("Aciton Event"+ e);
            if( e.target instanceof Checkbox )
            {
                if( e.target == chPkgProject )
                {
                    settings.PackProject = chPkgProject.getState();
                    refill(2 - settings.Mode);
                    return true;
                }else
                if( e.target == chPkgSystem )
                {
                    settings.PackSystem = chPkgSystem.getState();
                    refill(2 - settings.Mode);
                    return true;
                }else
                if( e.target == chObjClass )
                {
                    settings.ObjClass = chObjClass.getState();
                    refill(3 - settings.Mode);
                    return true;
                }else
                if( e.target == chObjInterface )
                {
                    settings.ObjInterface = chObjInterface.getState();
                    refill(3 - settings.Mode);
                    return true;
                }else
                if( e.target == chMemVariable )
                {
                    settings.MemVariable = chMemVariable.getState();
                    refill(4 - settings.Mode);
                    return true;
                }else
                if( e.target == chMemMethod )
                {
                    settings.MemMethod = chMemMethod.getState();
                    refill(4 - settings.Mode);
                    return true;
                }
                return super.handleEvent(e);

            }else
            if( e.target == chMode )
            {
                i = chMode.getSelectedIndex();
                if( i < 5 )
                {
                    BrSettings bs = new BrSettings(settings);
                    bs.Mode = i;
                   BrowserSettings.ChangePanel((Window)getParent(),bs);
                }else
                if( i > 5 )
                {
                    refill(0);
                    /*System.out.println("Choice");
                    listsObj[0] = getComponent(choiceObj[i-6]);
                    repaintList(0);
                    if( settings.Columns > 1 )
                    {
                        refill(1);
                        if( settings.Columns > 2 )
                            refill(2);
                    }*/
                }
                return true;
            }else
            if( e.target instanceof List )
            {// DOUBLE CLICK
                for(i=0;i<settings.Columns;i++)
                    if( e.target == list[i] )
                    {
                        OpenView(i,e);
                        return true;
                    }
                //System.out.println("double "+e.arg);
                return super.handleEvent(e);
            }
            return super.handleEvent(e);
        }else
        if( e.id == Event.LIST_SELECT )
        {
            //System.out.println("select ");
            for(i=0;i<settings.Columns;i++)
                if( e.target == list[i] )
                {
                    ListSelect(i,e);
                    return true;
                }
            //System.out.println("select "+e.arg);
            return super.handleEvent(e);
        }else //LIST_SELECT
        if( e.id == Event.LIST_DESELECT )
        {
            //System.out.println("deselect ");
            for(i=0;i<settings.Columns;i++)
                if( e.target == list[i] )
                {
                    ListDeselect(i,e);
                    return true;
                }
            //System.out.println("select "+e.arg);
        }else //LIST_DESELECT
        if( e.id == Event.MOUSE_DOWN )
        {
            //System.out.println("Mouse down" + e.modifiers + " click " + e.clickCount);
        }else
        if( e.id == Event.KEY_ACTION )
        {
            //System.out.println("Key action" + e.modifiers);
        }else
        if( e.id == Event.KEY_PRESS )
        {
            //System.out.println("Key press" + e.modifiers);
            BrSettings bs;
            switch( e.key )
            {
            case 's':
            case 'S':
                if( lastChanged instanceof BrObject )
                    new BrowserSettings(1,(BrWindow)getParent());
                else
                if( lastChanged instanceof BrMember )
                    new BrowserSettings(2,(BrWindow)getParent());
                else
                    new BrowserSettings(0,(BrWindow)getParent());
                break;
            case ' ':
                lastChanged.openView(BrowserSettings.mainWindow);
                break;
            case '1':
            case '2':
            case '3':
                bs = new BrSettings(settings);
                bs.Columns = e.key - '0';
                //System.out.println("num " + bs.Columns);
               BrowserSettings.ChangePanel((Window)getParent(),bs);
                break;
            case 'm':
                bs = new BrSettings(settings);
                bs.Choice = !settings.Choice;
               BrowserSettings.ChangePanel((Window)getParent(),bs);
                break;
            case 'x':
                bs = new BrSettings(settings);
                bs.Checkbox = !settings.Checkbox;
               BrowserSettings.ChangePanel((Window)getParent(),bs);
                break;
            case 'h':
            case 'H':
                if( (lastChanged instanceof BrObject) ||
                    (lastChanged instanceof BrMember) )
                    new HintWindow(BrowserSettings.mainWindow,lastChanged);
                break;
            case 'r':
            case 'R':
                if( lastChanged instanceof BrObject )
                    ObjectView.reparse((BrObject)lastChanged);
                else
                if( lastChanged instanceof BrMember )
                    ObjectView.reparse(((BrMember)lastChanged).object);
                else
                if( lastChanged instanceof BrPackage )
                    PackageView.reparse((BrPackage)lastChanged);
                break;
            case 'e':
            case 'E':
                if( lastChanged instanceof BrObject )
                    ObjectView.textEditor((BrObject)lastChanged);
                else
                if( lastChanged instanceof BrMember )
                    MemberView.textEditor((BrMember)lastChanged);
                break;
            case 'f':
            case 'F':
                if( lastChanged instanceof BrClass )
                {
                    BrClass o = (BrClass)lastChanged;
                    if( o.isForm )
                        ObjectView.formEditor(o,true);
                }
                break;
            case 'c':
            case 'C':
                if( lastChanged instanceof BrObject )
                    xelfi.compiler.XelfiCompiler.compileClass(
                        ((BrObject)lastChanged).getXFile().
                        getPackageAndName());
                break;
            }
        }
        return super.handleEvent(e);
    }
    public BrComponent[] getSelectedComponents(int comp)
    {
        if( (settings.Mode <= comp) && ((settings.Mode + settings.
             Columns) > comp) )
        {
            int l = comp - settings.Mode;
            int[] ind = list[l].getSelectedIndexes();
            int i,k = ind.length;
            BrComponent[] br = new BrComponent[k];
            for(i=0;i<k;i++)
                br[i] = listsObj[l][ind[i]];

            return br;
        }else
        if( settings.Choice && (settings.Mode == (comp + 1)) )
        {
            int l = chMode.getSelectedIndex() - 6;
            if( l < 0 ) return new BrComponent[0];
            BrComponent[] br = new BrComponent[1];
            br[0] = choiceObj[l];
            return br;
        }else return new BrComponent[0];
    }
}





















