
package xelfi.browser.view;

import xelfi.browser.util.*;
import xelfi.browser.document.*;
import xelfi.editor.Position;
import xelfi.editor.Source;
import xelfi.design.forms.XelfiDesignForm;

import java.awt.*;
import java.io.FileNotFoundException;
import java.io.IOException;


public class ObjectView extends xelfi.top.TopDialog
   implements modalObject
{

    BrObject object;
    boolean classView;
    Dialog d;

    public ObjectView(Frame parent,BrObject pObject) {

        super(parent, "Object view", false);
        object = pObject;

        Modifiers m = object.modifiers;
        if( object instanceof BrClass )
            classView = true;
        else
            classView = false;

        addNotify();
        resize(insets().left + insets().right + 2, insets().top + insets().bottom + 8);

        setLayout(new HorizLayout(HorizLayout.RESIZE,HorizLayout.CENTER));
        group1= new CheckboxGroup();

        panel2=new Panel();
        panel2.setLayout(new VertLayout(VertLayout.CENTER,VertLayout.TOP));

        panel3=new Panel();
        panel3.setLayout(new HorizLayout(HorizLayout.LEFT,HorizLayout.TOP));

        Panel panel;
        if( classView )
        {
            BrClass c = (BrClass)object;
            boolean form = c.isForm;
            String nname = (form ? "Form " : "Class ");
            setTitle(nname + c.getNameWithPackage());

            chAbstract = new Checkbox("Abstract");
            chAbstract.setState(m.abstractM());
            if( form ) chAbstract.disable();
            panel3.add(chAbstract);

            chFinal = new Checkbox("Final");
            chFinal.setState(m.finalM());
            if( form ) chFinal.disable();
            panel3.add(chFinal);

            //chPrivate=new Checkbox("Private",group1, true);
            //panel3.add(chPrivate);
            chPackage = new Checkbox("Package",group1, false);
            if( form ) chPackage.disable();
            panel3.add(chPackage);
            //chProtected=new Checkbox("Protected",group1, false);
            //panel3.add(chProtected);
            chPublic = new Checkbox("Public",group1, false);
            if( form ) chPublic.disable();
            panel3.add(chPublic);
            switch( m.access() )
            {
            case 0: chPublic.setState(true);break;
            case 1: chPackage.setState(true);break;
//            case 2: chPrivate.setState(true);break;
  //          case 3: chProtected.setState(true);break;
            }
            panel2.add(panel3);


            panel4 = new Panel();
            panel4.setLayout(new HorizLayout(HorizLayout.RESIZE,HorizLayout.TOP));

            panel = new Panel();
            panel.setLayout(new DLayout());
            Label l = new Label(nname + "name:");
            panel.add(l);
            editName = new TextField(object.name,20);
            if( form ) editName.disable();
            panel.add(editName);
            panel4.add(panel);

            if( form )
            {
                panel = new Panel();
                panel.setLayout(new DLayout());
                l = new Label(nname + "type:");
                panel.add(l);
                switch( xelfi.design.forms.XFFormLoader.checkFormType(
                    object.getXFile().getFormName()) )
                {
                case xelfi.design.util.XFDesignConstants.FT_NOFORM:
                    formType = new TextField("???",20);
                    break;
                case xelfi.design.util.XFDesignConstants.FT_APPLICATION:
                    formType = new TextField("Application",20);
                    break;
                case xelfi.design.util.XFDesignConstants.FT_FRAME:
                    formType = new TextField("Frame",20);
                    break;
                case xelfi.design.util.XFDesignConstants.FT_DIALOG:
                    formType = new TextField("Dialog",20);
                    break;
                case xelfi.design.util.XFDesignConstants.FT_APPLET:
                    formType = new TextField("Applet",20);
                    break;
                }
                formType.disable();
                panel.add(formType);
                panel4.add(panel);
            }

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label(nname + "file:");
            panel.add(l);
            editFile = new TextField(c.getXFile().getFileName(),20);
            if( form ) editFile.disable();
            panel.add(editFile);
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Extends:");
            panel.add(l);
            editExtends = new TextField(c.extendsModifier,20);
            if( form ) editExtends.disable();
            panel.add(editExtends);
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Implements:");
            panel.add(l);
            editImplements = new TextArea(3,20);
            if( form ) editImplements.disable();
            panel.add(editImplements);
            int i,k = c.implementsModifier.length;
            for(i=0;i<k;i++)
                editImplements.appendText(c.implementsModifier[i]+'\n');
            panel4.add(panel);
            panel2.add(panel4);
            add(panel2);
        }else // interface
        {
            BrInterface ii = (BrInterface)object;

            setTitle("Interface " + object.getNameWithPackage());

            chAbstract=new Checkbox("Abstract");
            chAbstract.setState(m.abstractM());
            panel3.add(chAbstract);

            chPackage=new Checkbox("Package",group1, false);
            panel3.add(chPackage);
            chPublic=new Checkbox("Public",group1, false);
            panel3.add(chPublic);
            switch( m.access() )
            {
            case 0: chPublic.setState(true);break;
            case 1: chPackage.setState(true);break;
            }
            panel2.add(panel3);


            panel4=new Panel();
            panel4.setLayout(new HorizLayout(HorizLayout.RESIZE,HorizLayout.TOP));

            panel = new Panel();
            panel.setLayout(new DLayout());
            Label l = new Label("Interface name:");
            panel.add(l);
            editName = new TextField(object.name,20);
            panel.add(editName);
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Interface file:");
            panel.add(l);
            editFile = new TextField(object.getXFile().getFileName(),20);
            panel.add(editFile);
            panel4.add(panel);

            panel = new Panel();
            panel.setLayout(new DLayout());
            l = new Label("Extends:");
            panel.add(l);
            editImplements = new TextArea(3,20);
            panel.add(editImplements);
            int i,k = ii.extendsModifier.length;
            for(i=0;i<k;i++)
                editImplements.appendText(ii.extendsModifier[i] + '\n');
            panel4.add(panel);
            panel2.add(panel4);
            add(panel2);
        }

        panel5 = new Panel();
        panel5.setLayout(new GridLayout(2,5));

        buttonTextEditor = new Button("Text Editor");
        panel5.add(buttonTextEditor);
        buttonFormEditor = new Button("Form Editor");
        if( !classView || !((BrClass)object).isForm )
            buttonFormEditor.disable();

        panel5.add(buttonFormEditor);
        buttonNewBrowser = new Button("New Browser");
        buttonNewBrowser.disable();
        //panel5.add(buttonNewBrowser);
        buttonHint = new Button("Hint");
        panel5.add(buttonHint);
        buttonReparse = new Button("Reparse");
        panel5.add(buttonReparse);

        buttonNew = new Button("New");
        //panel5.add(buttonNew);
        //.disable();
        buttonDelete = new Button("Delete");
        buttonDelete.disable();
        //panel5.add(buttonDelete);
        buttonAddToProject = new Button("Add to project");
        //panel5.add(buttonAddToProject);
        buttonMarkAsMain = new Button("Mark as main");
        if( !classView )
            buttonMarkAsMain.disable();
        buttonMarkAsMain.disable();
        //panel5.add(buttonMarkAsMain);
        buttonCompile = new Button("Compile");
        panel5.add(buttonCompile);
        add(panel5);

        panel1=new Panel();
        panel1.setLayout(new GridLayout(1,2));

        panel = new Panel();
        panel.setLayout(new FlowLayout());
        buttonCopy=new Button("Copy");
        //panel.add(buttonCopy);
        buttonCopy.disable();
        buttonPaste=new Button("Paste");
        if( (BrowserSettings.Clipboard == null) ||
            !(BrowserSettings.Clipboard[0] instanceof
                xelfi.browser.document.BrProject) )
            buttonPaste.disable();
        //panel.add(buttonPaste);
        buttonCut=new Button("Cut");
        buttonCut.disable();
        //panel.add(buttonCut);
        panel1.add(panel);

        panel = new Panel();
        panel.setLayout(new FlowLayout());
        buttonOK=new Button("OK");
        panel.add(buttonOK);
        buttonCancel=new Button("Cancel");
        panel.add(buttonCancel);
        buttonHelp=new Button("Help");
        buttonHelp.disable();
        //panel.add(buttonHelp);
        panel1.add(panel);
        add(panel1);



        resize(insets().left + insets().right + preferredSize().width,
            insets().top + insets().bottom + preferredSize().height);

       setResizable(false);
        Dimension d = getToolkit().getScreenSize();
        move( (d.width - size().width) / 2 , (d.height - size().height) / 2 );
        show();
        resize(preferredSize());

    }

    /*public synchronized void show() {
       Rectangle bounds = getParent().bounds();
       Rectangle abounds = bounds();

       move(bounds.x + (bounds.width - abounds.width)/ 2,
            bounds.y + (bounds.height - abounds.height)/2);

       super.show();
    }*/

    public synchronized void wakeUp() {
       notify();
    }

    public boolean handleEvent(Event event) {

       if (event.id == Event.WINDOW_DESTROY) {
           dispose();
           return true;
       }else
        if( event.id == Event.ACTION_EVENT )
        {
            if( event.target == buttonTextEditor )
            {
                dispose();
                textEditor(object);
                return true;
            }else
            if( event.target == buttonFormEditor )
            {
                dispose();
                formEditor(object,true);
                return true;
            }else
            if( event.target == buttonNewBrowser )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonHint )
            {
                dispose();
                new HintWindow(BrowserSettings.mainWindow,object);
                /*System.out.println("otevrit");
                Source s = xelfi.top.TopLevel.showEditor(
                    object.getXFile(),true);
                if( object.getBodyEnd() == null )
                    System.out.println("null");
                System.out.println("otevrit 1");
                xelfi.top.TopLevel.showEditor(s,object.getBodyEnd(),true);
                System.out.println("otevreno");*/
                return true;
            }else
            if( event.target == buttonReparse )
            {
                dispose();
                reparse(object);
                return true;
            }else
            if( event.target == buttonNew )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonDelete )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonAddToProject )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonMarkAsMain )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonCompile )
            {
                dispose();
                xelfi.compiler.XelfiCompiler.compileClass(object.getXFile().
                    getPackageAndName());
                return true;
            }else
            if( event.target == buttonCopy )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonPaste )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonCut )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonOK )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonCancel )
            {
                dispose();
                return true;
            }else
            if( event.target == buttonHelp )
            {
                dispose();
                return true;
            }
        }
       return super.handleEvent(event);
    }


    public void onOk(int index)
    {
        switch( index )
        {
        case 1:
            break;
        case 2:
            break;
        case 3:
            break;
        case 4:
            break;
        }
    }
    public void onNo(int index)
    {
        switch( index )
        {
        case 1:
            break;
        case 2:
            break;
        case 3:
            break;
        case 4:
            break;
        case 5:
            break;
        }
    }
    public void onCancel(int index)
    {
        switch( index )
        {
        case 1:
            break;
        case 2:
            break;
        case 3:
            break;
        }
    }
    static void textEditor(BrObject object)
    {
        //System.out.println("otevrit");
        Source s = null;
        if( (object instanceof BrClass) &&
            ((BrClass)object).isForm )
        {
            s = formEditor(object,false).getSource();
            if( s == null ) return;
        }else
            try{
                s = new Source(object.getXFile());
            }catch(IOException e)
            {
                new modalDialog(BrowserSettings.mainWindow,
                    null,0,"IO Exception ",
                    null,null,
                    modalDialog.OK);
                return;
            }

        if( !object.isLoaded )
        {
            System.out.println("Error 624");
        }
        if( object.getBegin() == null )
            System.out.println("Error 625");
        //System.out.println("otevrit 1");
        s.showAll ();
        xelfi.top.TopLevel.showEditor(s,object.getBegin(),true);
        //System.out.println("otevreno");
        return;
    }
    static void reparse(BrObject object)
    {
        try
        {
            ComponentManager.reparseFile(object.getXFile());
        }catch(FileNotFoundException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"File not exists! ",
                "You must reparse package. ",null,
                modalDialog.OK);
        }catch(IOException e)
        {
            new modalDialog(BrowserSettings.mainWindow,
                null,0,"IO Exception ",
                null,null,
                modalDialog.OK);
        }
        BrowserSettings.repaint(3);
        return;
    }
    static XelfiDesignForm formEditor(BrObject object,boolean focus)
    {
        XFile x = object.getXFile();
        //System.out.println("showForm..." +
        //    x.getAllPath() + x.getName() + ".form");
        /*xelfi.top.TopLevel.showForm(
            x.getAllPath() + x.getName() + ".form",true);*/

        return xelfi.top.TopLevel.showForm(x,focus);
    }


    Panel panel2;
    Panel panel1;
    Panel panel3;
    Panel panel8;
    Panel panel4;
    Panel panel5;
    Panel panel6;
    Panel panel7;
    CheckboxGroup group1;
    Button buttonTextEditor,
        buttonFormEditor ,
        buttonNewBrowser ,
        buttonHint ,
        buttonReparse ,

        buttonNew ,
        buttonDelete ,
        buttonAddToProject ,
        buttonMarkAsMain ,
        buttonCompile ,

        buttonCopy ,
        buttonPaste ,
        buttonCut;

    Button buttonOK;
    Button buttonCancel;
    Button buttonHelp;

    Checkbox chFinal;
    Checkbox chAbstract;
    Checkbox chPublic;
    Checkbox chPrivate;
    Checkbox chProtected;
    Checkbox chPackage;
    Checkbox chPProtected;
    TextField editName,formType;
    TextField editFile;
    TextField editExtends;
    TextArea editImplements;
}








