/** XelfiCommpiler class
* @author: Filip Dvorak
* @version: 1.3
*/

package xelfi.compiler;

import java.io.*;

import xelfi.execution.StreamPipe;

class ExternalCompiler implements MainCompiler
{
  XelfiCompilerOutput outStream;

  ExternalCompiler(XelfiCompilerOutput outS)
  {
    outStream = outS;
  }

  public void compileClass(File f)
  {
    Runtime rt = Runtime.getRuntime();
    Process child = null;
    try
    {
      child = rt.exec(CompilerOptions.getExternalCompilerPath() + " " + f.toString());
    }
    catch(IOException e)
    {
      outStream.topLevelError("Cannot start external compiler: " + e);
    }
    StreamPipe childOut = new StreamPipe(outStream, child.getInputStream(), false);
    StreamPipe childErr = new StreamPipe(outStream, child.getErrorStream(), false);

    Thread t = new Thread(childErr);
    t.setPriority(Math.max(Thread.currentThread().getPriority() - 2, Thread.MIN_PRIORITY));
    t.start();

    childOut.run();
  }
}



