/**
 * DebuggerOptionsPanel
 *
 * @author Roman Blazevic
 * @version 970208
 */

package xelfi.debugger;

import java.awt.*;

/**
 * This is a panel used in the XelfiOptions dialog
 */

class DebuggerOptionsPanel extends Panel
{
	private DebuggerOptions options;
	Checkbox showArrayIndexesCheckbox;
	TextField depthOfResursiveWatchingEdit;

	/**
	 * DebuggerOptionsPanel constructor.
	 */
	DebuggerOptionsPanel(DebuggerOptions options)
	{
		super();

		this.options = options;

		showArrayIndexesCheckbox = new Checkbox("show array indexes");
		showArrayIndexesCheckbox.setState(options.showArrayIndexes());

		depthOfResursiveWatchingEdit = new TextField(Integer.toString(options.getDepthOfRecursiveWatching()), 2);

		add("Center", showArrayIndexesCheckbox);
		add("Center", new Label("depth of recursive watching"));
		add(depthOfResursiveWatchingEdit);
	}

	/**
	 * Gets the data from the panel.
	 */
	DebuggerOptions getDebuggerOptions()
	{
		options.setShowArrayIndexes(showArrayIndexesCheckbox.getState());

		try
		{
			int n = Integer.valueOf(depthOfResursiveWatchingEdit.getText()).intValue();

			if (n > 0)
				options.setDepthOfRecursiveWatching(n);
		}
		catch (Exception e)
		{ }

		return options;
	}
}

