/**
* Xelfi
*/

package xelfi.design.components;

import java.util.Vector;

/**
 * XelfiVisualContainer Interface is a common interface for visual containers that can be used 
 * during Xelfi design time.
 * @version 	1.10, 20 Feb 1997
 *		from 1.10 setDesignLayout returns value
 * @author 	Ian Formanek
 */
public interface XelfiVisualContainer extends XelfiVisualComponent {

	/**
	 * Method to get container's design layout.
	 * @return		container's design layout
	 * @see #setDesignLayout
	 * @see XelfiDesignLayout
	 */
	public XelfiDesignLayout getDesignLayout();

	/**
	 * Method to set container's design layout.
	 * @param	aXLayout		container's design layout
	 * @return		one of RSP_??? constants defined in XFDesignConstants.
	 * @see #setDesignLayout
	 * @see XelfiDesignLayout
	 */
	public int setDesignLayout(XelfiDesignLayout aXLayout);
	
	/**
	 * Method to get Vector of container's subcomponents.
	 * @return		vector of container's subcomponents
	 */
	public Vector getSubComponents();
}	