/**
* Xelfi
*/

package xelfi.design.components.dialogs;

import java.awt.*;
import xelfi.design.components.*;
import xelfi.design.util.XFDesignConstants;
import xelfi.top.TopLevel;

/**
 * ColorSelectThread class is here only to get working modal XFFontDialog 
 * with JDK 1.02 under Win32 (Sunsoft claimed that this bug is fixed in JDK 1.02
 * but not under Win32 - the show() method of the Dialog class is still not blocking)
 *
 * @version 	1.21, 04 Feb 1997
 * @author 	Petr Hamernik, Ian Formanek
 */

public class ColorSelectThread extends Thread {
	private Frame parent;
	private XelfiDesignComponent xdc;
	private int propNum;
	private Container compParent;
	
	public ColorSelectThread(String name, Frame aParent, XelfiDesignComponent aXdc, 
										int aPropNum) {
		super(name);		
		parent = aParent;
		xdc = aXdc;
		propNum = aPropNum;
	}

	public void run() {
		Object of = null;
		try {
			of = xdc.getProperty(propNum);
		} catch (XFPropertyIndexOutOfBoundsException e) { }
		if (of instanceof Color) {
			XFColorDialog fsd = new XFColorDialog(parent, (Color) of);
			fsd.show();
			setPriority(MIN_PRIORITY);
			do { } while (fsd.finished != true);
			
			if (fsd.result == XFColorDialog.RES_OK) {
	
				try {
					int ret = xdc.setProperty(propNum, fsd.getSelColor());
					// this must happen always because CI must be notified to
					// redraw this property
					TopLevel.getInspector().propertiesChanged();
				} catch (XFPropertyBadValueTypeException e) {	
				} catch (XFPropertyIndexOutOfBoundsException e) {
				}
			}
		}
	}
}