/**
* Xelfi
*/

package xelfi.design.components.dialogs;

import java.awt.*;
import java.util.Vector;
import xelfi.design.components.palette.*;
import xelfi.design.components.*;
import xelfi.top.TopLevel;
import xelfi.awt.*;

/**
 * @version 	1.5 , 06 Jan 1997
 * @author 	Petr Hamernik
 */

public class ComponentPaletteEditor extends Dialog {
	List pages;
	List comp;
	Button insertPage;
	Button deletePage;
	Button renamePage;
	SpinButton spinPage;
	Label label1;
	Label label2;
	Button insertComp;
	Button deleteComp;
	SpinButton spinComp;
	Button OKBut;
	Button CancelBut;
	Button defaultPalette;
	
	Frame par = null;
	
	Vector data = null;
	
	int EDIT_1 = 6969;
	int EDIT_2 = 6968;
	int EDIT_3 = 6967;

    public ComponentPaletteEditor(Frame parent) {

		super(parent, "Component Palette Manager", true);
		par = parent;
		setBackground(Color.lightGray);
		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 628, insets().top + insets().bottom + 258);

		pages=new List();
		add(pages);
		pages.reshape(insets().left + 10,insets().top + 33,133,190);
		comp=new List();
		add(comp);
		comp.reshape(insets().left + 226,insets().top + 33,313,190);
		insertPage=new Button("Insert");
		add(insertPage);
		insertPage.reshape(insets().left + 153,insets().top + 72,63,24);
		deletePage=new Button("Delete");
		add(deletePage);
		deletePage.reshape(insets().left + 153,insets().top + 104,63,24);
		renamePage=new Button("Rename");
		add(renamePage);
		renamePage.reshape(insets().left + 153,insets().top + 136,63,24);
		spinPage=new SpinButton();
		add(spinPage);
		spinPage.setOrientation(false);
		spinPage.reshape(insets().left + 153,insets().top + 32,63,32);
		label1=new Label("Pages");
		add(label1);
		label1.reshape(insets().left + 18,insets().top + 8,63,24);
		label2=new Label("Components");
		add(label2);
		label2.reshape(insets().left + 225,insets().top + 8,108,24);
		insertComp=new Button("Insert");
		add(insertComp);
		insertComp.reshape(insets().left + 549,insets().top + 72,63,24);
		deleteComp=new Button("Delete");
		add(deleteComp);
		deleteComp.reshape(insets().left + 549,insets().top + 104,63,24);
		defaultPalette=new Button("Default");
		add(defaultPalette);
		defaultPalette.reshape(insets().left + 549,insets().top + 136,63,24);
		spinComp=new SpinButton();
		add(spinComp);
		spinComp.setOrientation(false);
		spinComp.reshape(insets().left + 549,insets().top + 32,63,32);
		OKBut=new Button("OK");
		add(OKBut);
		OKBut.reshape(insets().left + 549,insets().top + 168,63,24);
		CancelBut=new Button("Cancel");
		add(CancelBut);
		CancelBut.reshape(insets().left + 549,insets().top + 200,63,24);
		
		setResizable(false);
		
		data = new Vector();
		loadDataFromPalette();
    }

    public synchronized void show() {
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension screenSize = toolkit.getScreenSize();
		Dimension dialogSize = size();
		move((screenSize.width-dialogSize.width)/2,(screenSize.height-dialogSize.height)/2);
		super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == CancelBut) {
			hide();
			dispose();
   	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == OKBut) {
			XelfiComponentPalette pal = TopLevel.getPalette();
			pal.removeAllPages();
			for (int i = 0; i < data.size(); i++) {
				pal.addPage(pages.getItem(i));
				Vector v = (Vector) data.elementAt(i);
				for (int j = 0; j < v.size(); j++)
					pal.addComponent(i, (String) v.elementAt(j));
			}
			pal.setAddMenu();
			hide();
			dispose();
   	    	return true;
    	}
    	else 
    	if (event.id == Event.ACTION_EVENT && event.target == defaultPalette) {
			Vector def = XFComponentPaletteDefault.get();
			data = new Vector();
			pages.clear();
			comp.clear();
			for (int i = 0; i < def.size(); i++) {
				Vector v = (Vector) def.elementAt(i);
				pages.addItem((String) v.elementAt(0));
				Vector vnew = (Vector) v.clone();
				vnew.removeElementAt(0);
				data.addElement(vnew);
			}
			pages.select(0);
			updateComp();
   	    	return true;
    	}
    	else 
    	if (event.id == Event.LIST_SELECT && event.target == pages) {
			updateComp();
   	    	return true;
    	}
    	else 
    	if (event.id == Event.LIST_SELECT && event.target == comp) {
			updateSpinComp();
   	    	return true;
    	}
    	else 
    	if (event.id == Event.ACTION_EVENT && event.target == deleteComp) {
			int i = comp.getSelectedIndex();
			if (i != -1) {
				comp.delItem(i);
				int c = comp.countItems();
				if (c != 0) {
					if (i == c)
						i = c - 1;
					comp.select(i);
				}
				updateData();
			}
			return true;
    	}
    	else 
    	if (event.id == Event.ACTION_EVENT && event.target == insertComp) {
			if ((pages.countItems() != 0) && (pages.getSelectedIndex() != -1)) {
				XFInputLineDialog inputBox;
				inputBox = new XFInputLineDialog(par, "New Component", this, (String)null, EDIT_3);
				inputBox.show();
			}
	    	return true;
    	}
		else
		if (event.id == EDIT_3) {
			Class xx;
			XelfiDesignComponent xvc = null;
			String errMsg = null;
			try {
				xx = Class.forName((String) event.arg);
				xvc = (XelfiDesignComponent) xx.newInstance();
			} catch (IllegalAccessException e) {
				errMsg = "Illegal Access Exception";
			} catch (InstantiationException e) {
				errMsg = "Instantiation Exception";
			} catch (ClassNotFoundException e) {
				errMsg = "Class Not Found";
			} catch (ClassCastException e) {
				errMsg = "ClassCastException";
			}
			if (errMsg == null) {
				int i = comp.getSelectedIndex();
				if (i == -1)
					i = 0;
				comp.addItem((String) event.arg, i);
				comp.select(i);
				updateData();
			}
			else {
				XFMessageBox box = new XFMessageBox(par, "Error", errMsg + ": " + ((String) event.arg));
				box.show();
			}
			return true;
		}
    	else 
    	if (event.id == SpinButton.SPIN_DOWN && event.target == spinComp) {
			int i = comp.getSelectedIndex();
			if ((i != -1) && (i < comp.countItems() - 1)) {
				String s = comp.getItem(i);
				comp.replaceItem(comp.getItem(i + 1), i);
				comp.replaceItem(s, i + 1);
				comp.select(i + 1);
				updateData();
			}
   	    	return true;
    	}
    	else 
    	if (event.id == SpinButton.SPIN_UP && event.target == spinComp) {
			int i = comp.getSelectedIndex();
			if (i > 0) {
				String s = comp.getItem(i);
				comp.replaceItem(comp.getItem(i - 1), i);
				comp.replaceItem(s, i - 1);
				comp.select(i - 1);
				updateData();
			}
   	    	return true;
    	}
    	else 
    	if (event.id == SpinButton.SPIN_DOWN && event.target == spinPage) {
			int i = pages.getSelectedIndex();
			if ((i != -1) && (i < pages.countItems() - 1)) {
				String s = pages.getItem(i);
				pages.replaceItem(pages.getItem(i + 1), i);
				pages.replaceItem(s, i + 1);
				pages.select(i + 1);
				Vector v = (Vector) data.elementAt(i);
				data.setElementAt(data.elementAt(i + 1), i);
				data.setElementAt(v, i + 1);
			}
			spinPage.setValue(pages.countItems() - 1 - pages.getSelectedIndex());
   	    	return true;
    	}
    	else 
    	if (event.id == SpinButton.SPIN_UP && event.target == spinPage) {
			int i = pages.getSelectedIndex();
			if (i > 0) {
				String s = pages.getItem(i);
				pages.replaceItem(pages.getItem(i - 1), i);
				pages.replaceItem(s, i - 1);
				pages.select(i - 1);
				Vector v = (Vector) data.elementAt(i);
				data.setElementAt(data.elementAt(i - 1), i);
				data.setElementAt(v, i - 1);
			}
			spinPage.setValue(pages.countItems() - 1 - pages.getSelectedIndex());
   	    	return true;
    	}
    	else 
    	if (event.id == Event.ACTION_EVENT && event.target == renamePage) {
			int i = pages.getSelectedIndex();
			if (i != -1) {
				XFInputLineDialog inputBox;
				inputBox = new XFInputLineDialog(par, "Rename Page", this, pages.getItem(i), EDIT_2);
				inputBox.show();
			}
	    	return true;
    	}
		else
		if (event.id == EDIT_2) {
			int i = pages.getSelectedIndex();
			pages.replaceItem((String) event.arg, i);
			pages.select(i);
			return true;
		}
    	else 
    	if (event.id == Event.ACTION_EVENT && event.target == deletePage) {
			int i = pages.getSelectedIndex();
			if (i != -1) {
				pages.delItem(i);
				data.removeElementAt(i);
				int c = pages.countItems();
				if (c != 0) {
					if (i == c)
						i = c - 1;
					pages.select(i);
				}
				updateComp();
			}
			return true;
    	}
    	else 
    	if (event.id == Event.ACTION_EVENT && event.target == insertPage) {
			XFInputLineDialog inputBox;
			inputBox = new XFInputLineDialog(par, "New Page", this, (String)null, EDIT_1);
			inputBox.show();
	    	return true;
    	}
		else
		if (event.id == EDIT_1) {
			int i = pages.getSelectedIndex();
			if (i == -1)
				i = 0;
			pages.addItem((String) event.arg, i);
			pages.select(i);
			data.insertElementAt(new Vector(), i);
			updateComp();
			return true;
		}
    	else
    	if (event.id == Event.WINDOW_DESTROY) {
    	    hide();
	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

	void updateData() {
        int i = pages.getSelectedIndex();
        if (i != -1) {
			Vector v = new Vector();
			
			for (int j = 0; j < comp.countItems(); j++)
				v.addElement(comp.getItem(j));
			data.setElementAt(v, i);
			updateSpinComp();
		}
	}

	void updateSpinComp() {
		spinComp.setMinimum(0);
		spinComp.setMaximum(comp.countItems() - 1);
		spinComp.setValue(comp.countItems() - 1 - comp.getSelectedIndex());
	}
	
	void updateComp() {
        int i = pages.getSelectedIndex();
        if (i != -1) {
			Vector v = (Vector) data.elementAt(i);
			
			comp.clear();
			for (int j = 0; j < v.size(); j++)
				comp.addItem((String) v.elementAt(j));
		}
		else
			comp.clear();
		spinPage.setMinimum(0);
		spinPage.setMaximum(pages.countItems() - 1);
		spinPage.setValue(pages.countItems() - 1 - i);
		spinComp.setMinimum(0);
		spinComp.setMaximum(0);
		spinComp.setValue(0);
	}

	void loadDataFromPalette() {
		data = new Vector();
		pages.clear();
		comp.clear();

		XelfiComponentPalette pal = TopLevel.getPalette();
		for (int i = 0; i < pal.getPagesCount(); i++) {
			pages.addItem(pal.getPageName(i));
			Vector v = new Vector();
			for (int j = 0; j < pal.getComponentsCount(i); j++)
				v.addElement(new String(pal.getComponentName(i,j)));
			data.addElement(v);
		}
		pages.select(0);
		updateComp();
	}
}
