/**
* Xelfi
*/

package xelfi.design.components.dialogs;

import java.awt.*;

/**
 * @version 	1.00, 03 Dec 1996
 * @author 	Petr Hamernik
 */


public class XFInputLineDialog extends Dialog {
    Button OKBut;
    Button CancelBut;
    TextField edit;

	private Component answer = null;

	private int eventId = -1;

    public XFInputLineDialog(Frame parent, String label, Component aAnswer, String aText, int aEventId) {
	    super(parent, label, true);
		eventId = aEventId;
		answer = aAnswer;

        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 320, insets().top + insets().bottom + 80);
        edit=new TextField(41);
        add(edit);
        edit.reshape(insets().left + 10,insets().top + 10,300,24);
        OKBut=new Button("OK");
        add(OKBut);
        OKBut.reshape(insets().left + 70,insets().top + 45,70,24);
        CancelBut=new Button("Cancel");
        add(CancelBut);
        CancelBut.reshape(insets().left + 160,insets().top + 45,70,24);
    	setResizable(false);
		if (aText != null) {
			edit.setText(aText);
		}
    }

    public synchronized void show() {
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension screenSize = toolkit.getScreenSize();
		Dimension dialogSize = size();
		move((screenSize.width-dialogSize.width)/2,(screenSize.height-dialogSize.height)/2);
		super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
		if (event.target == OKBut) {
			hide();
			answer.postEvent(new Event(this, eventId, new String(edit.getText())));
			dispose();
			return true;
		}
		else if (event.target == CancelBut) {
			hide();
			dispose();
			return true;
		}
		else
    	if (event.id == Event.WINDOW_DESTROY) {
    	    hide();
	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

}


