/**
* Xelfi
*/

package xelfi.design.components.palette;

/**
 * @version 	1.2 21 Jan 1997
 * @author		Petr Hamernik
 */

import java.awt.*;
import xelfi.awt.ImageCheckButton;
import xelfi.top.MainMenu;
import xelfi.top.TopLevel;


public class PaletteButton extends ImageCheckButton {
	private String hint = null;
	private static String origHint = null;
	
	public PaletteButton(Image image, String aHint) {
		super(image);
		hint = aHint;
		origHint = TopLevel.getMenu().getTitle();
	}
	
	public synchronized boolean mouseEnter(Event evt, int x, int y)  {
		if (hint != null)
			TopLevel.getMenu().setTitle(origHint+" ["+hint+"]");
		return super.mouseEnter(evt, x, y);
	}
	
	public synchronized boolean mouseExit(Event evt, int x, int y) {
		if ((hint != null) && (origHint != null)) {
			if (TopLevel.getMenu().getTitle().compareTo(origHint+" ["+hint+"]") == 0)
				TopLevel.getMenu().setTitle(origHint);
		}
		return super.mouseExit(evt, x, y);
	}
}


