/**
* Xelfi
*/

package xelfi.design.components.palette;

/**
 * @version 	1.6 07 Dec 1996
 * @author		Petr Hamernik
 */

import java.awt.*;
import xelfi.util.EnhProperties;

public interface XelfiComponentPalette {
    public int getPagesCount();
	public int getPageIndex();
    public String getPageName(int index) throws ArrayIndexOutOfBoundsException;
    public void addPageAt(String name, int position) throws ArrayIndexOutOfBoundsException;
    public void addPage(String name);

	public int getComponentsCount(int Page) throws ArrayIndexOutOfBoundsException;
    public void addComponent(int page, String component) throws ArrayIndexOutOfBoundsException;
    public void addComponentAt(int page, int position, String component)
		throws ArrayIndexOutOfBoundsException;

	public void setAddMenu();
	public void paletteDefault();
	
	public void removePageAt(int Page) throws ArrayIndexOutOfBoundsException;
	public void removeAllPages();
	public int getPageIndex(String Name) throws ArrayIndexOutOfBoundsException;
	public String getComponentName(int Page, int Position) throws ArrayIndexOutOfBoundsException;

	public boolean loadPalette(EnhProperties prop);
	public void storePalette(EnhProperties prop);

    public void setBorderColor(Color col);
    public Color getBorderColor(Color col);
	public void setBackground(Color  c);
	public void setFont(Font  f);
	public void setForeground(Color  c);

    public int getMode();
	public boolean setAddMode(String comp);
    public String getAddComponent();
    public void setSelectionMode();
}
