/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik
  *
  */

import java.awt.*;
import java.io.*;
import xelfi.awt.SpinButton;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.XFDesignConstants;
import xelfi.design.util.XFDesignOptions;
import xelfi.design.util.XFDesignUtils;

public class XSpinButton extends XAWTPanel {
	private SpinButton spin;

	private static int propertyCount = 15;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 4;
	private String events[] = new String[eventCount];
	protected static Image icon = null;
	
	public XSpinButton() { 
		super(XAWTPanel.WITHOUT_DRAGBORDER);
		setComponent(spin = new SpinButton());
		spin.propagate = true;
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("spinbutton.gif");
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "xelfi.awt.SpinButton";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	public boolean handleEvent(Event evt) {
		evt.target = this;
		if (XFDesignOptions.designMode == XFDesignConstants.DM_REAL)
			spin.propagate = false;
		else
			spin.propagate = true;
		return super.handleEvent(evt);
	}

	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return ((Color) propDef[i]).equals(spin.getBackground());
			case 1: return ((Color) propDef[i]).equals(spin.getForeground());
			case 2: return (((Boolean) propDef[i]).booleanValue() == spin.isEnabled());
			case 3: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 4: return (((Boolean) propDef[i]).booleanValue() == autoSize);
			case 5: return (((Boolean) propDef[i]).booleanValue() == parentColor);
			case 6: return (((Integer) propDef[i]).intValue() == spin.getValue());
			case 7: return (SpinButton.defaultMinimum == spin.getMinimum());
			case 8: return (SpinButton.defaultMaximum == spin.getMaximum());
			case 9: return (SpinButton.defaultStep == spin.getStep());
			case 10: return (SpinButton.defaultRepeatDelay == spin.getDelay());
			case 11: return (SpinButton.defaultRepeatRate == spin.getRate());
			case 12: return (SpinButton.defaultBorderColor.equals(spin.getBorderColor()));
			case 13: return (SpinButton.defaultBorderWidth == spin.getBorderWidth());
			case 14: return (SpinButton.defaultOrientation == spin.getOrientation());
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;
		if (getBackground() != null)
				propDef[0] = new Color(spin.getBackground().getRGB());
		if (getForeground() != null)
				propDef[1] = new Color(spin.getForeground().getRGB());
		propDef[2] = new Boolean(spin.isEnabled());
		propDef[3] = new Boolean(bVisible);
		propDef[4] = new Boolean(autoSize);
		propDef[5] = new Boolean(parentColor);
		propDef[6] = new Integer(spin.getValue());
		propDef[7] = new Integer(-1);
		propDef[8] = new Integer(-1);
		propDef[9] = new Integer(-1);
		propDef[10] = new Integer(-1);
		propDef[11] = new Integer(-1);
		propDef[12] = new Integer(-1);
		propDef[13] = new Integer(-1);
		propDef[14] = new Integer(-1);
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return spin.getBackground();
			case 1: return spin.getForeground();
			case 2: return (spin.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 4: return (autoSize) ? Boolean.TRUE : Boolean.FALSE;
			case 5: return (parentColor) ? Boolean.TRUE : Boolean.FALSE;
			case 6: return new Integer(spin.getValue());
			case 7: return new Integer(spin.getMinimum());
			case 8: return new Integer(spin.getMaximum());
			case 9: return new Integer(spin.getStep());
			case 10: return new Integer(spin.getDelay());
			case 11: return new Integer(spin.getRate());
			case 12: return spin.getBorderColor();
			case 13: return new Integer(spin.getBorderWidth());
			case 14: return (spin.getOrientation()) ? Boolean.TRUE : Boolean.FALSE;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = new String("Background Color"); 
		list[1] = new String("Foreground Color"); 
		list[2] = new String("Enabled"); 
		list[3] = new String("Visible"); 
		list[4] = new String("Auto Size"); 
		list[5] = new String("Parent Color"); 
		list[6] = new String("Value");
		list[7] = new String("Minimum");
		list[8] = new String("Maximum");
		list[9] = new String("Step");
		list[10] = new String("Repeat Delay");
		list[11] = new String("Repeat Rate");
		list[12] = new String("Border Color");
		list[13] = new String("Border Width");
		list[14] = new String("Orientation");
		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: 
			case 1: return XColorPropertyType.viewString(getProperty(index));
			case 2:
			case 3:
			case 4: 
			case 5: return XBooleanPropertyType.viewString(getProperty(index));
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
			case 11: return XIntegerPropertyType.viewString(getProperty(index));
			case 12: return XColorPropertyType.viewString(getProperty(index));
			case 13: return XIntegerPropertyType.viewString(getProperty(index));
			case 14: return XBooleanPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: 
			case 1: return XFDesignConstants.PVT_SPECIAL;
			case 2:
			case 3:
			case 4: 
			case 5: return XFDesignConstants.PVT_CHECK;
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
			case 11: return XFDesignConstants.PVT_INPUT_INT;
			case 12: return XFDesignConstants.PVT_SPECIAL;
			case 13: return XFDesignConstants.PVT_INPUT_INT;
			case 14: return XFDesignConstants.PVT_CHOICE_STRICT;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 14: String[] ret = new String[2];
					ret[0] = "LEFT-RIGHT";
					ret[1] = "UP-DOWN";
					return ret;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 14: Boolean[] ret = new Boolean[2];
					ret[0] = new Boolean(true);
					ret[1] = new Boolean(false);
					return ret;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0: if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					spin.setBackground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					spin.repaint();
					break;
			case 1:	if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					spin.setForeground((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					if (parentColor) {
						parentColor = false;
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					}
					spin.repaint();
					break;
			case 2:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					spin.enable(((Boolean)value).booleanValue());
					break;
			case 3: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 4:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setAutoSize(((Boolean)value).booleanValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						spin.repaint();
					}
					regen = regen | XFDesignConstants.GEN_RESHAPE;
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 5:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentColor(((Boolean)value).booleanValue());
					if (parentColor)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 6: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					spin.setValue(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 7: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					spin.setMinimum(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 8: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					spin.setMaximum(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 9: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					spin.setStep(((Integer)value).intValue());
					ret = ret | XFDesignConstants.RSP_OTHER_PROP;
					break;
			case 10: if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					spin.setDelay(((Integer)value).intValue());
					break;
			case 11:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					spin.setRate(((Integer)value).intValue());
					break;
			case 12:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					spin.setBorderColor((Color)value);
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 13:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					spin.setBorderWidth(((Integer)value).intValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						spin.repaint();
					}
					break;
			case 14:if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					spin.setOrientation(((Boolean)value).booleanValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						spin.repaint();
					}
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 0:
			case 1: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			case 12: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnGotFocus";
		list[1] = "OnLostFocus";
		list[2] = "OnDownClick";
		list[3] = "OnUpClick";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "SpinButton";
	}
	
	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT: 
				gen = name + " = new " + getClassName() + "();\n";
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: if (!parentColor)
										gen = gen + name + ".setBackground(" +
											XFDesignUtils.genColor(spin.getBackground()) + ");\n";
									break;
							case 1: if (!parentColor)
										gen = gen + name + ".setForeground(" +
											XFDesignUtils.genColor(spin.getForeground()) + ");\n";
									break;
							case 2: gen = gen + name + (spin.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 3: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 6: gen = gen + name + ".setValue(" + spin.getValue() + ");\n";
									break;
							case 7: gen = gen + name + ".setMinimum(" + spin.getMinimum() + ");\n";
									break;
							case 8: gen = gen + name + ".setMaximum(" + spin.getMaximum() + ");\n";
									break;
							case 9: gen = gen + name + ".setStep(" + spin.getStep() + ");\n";
									break;
							case 10: gen = gen + name + ".setDelay(" + spin.getDelay() + ");\n";
									break;
							case 11: gen = gen + name + ".setRate(" + spin.getRate() + ");\n";
									break;
							case 12: gen = gen + name + ".setBorderColor(" +
										XFDesignUtils.genColor(spin.getBorderColor()) + ");\n";
									break;
							case 13: gen = gen + name + ".setBorderWidth(" + spin.getBorderWidth() + ");\n";
									break;
							case 14: gen = gen + name + ".setOrientation(" + (spin.getOrientation() ? "true" : "false") + ");\n";
									break;
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			case 2: return evt +".id == SpinButton.SPIN_DOWN && "+evt+".target == "+getName();
			case 3: return evt +".id == SpinButton.SPIN_UP && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean())
				propDef[i] = null;
			else switch (i) {
				case 0: spin.setBackground(XColorPropertyType.loadFromStream(stream)); break;
				case 1: spin.setForeground(XColorPropertyType.loadFromStream(stream)); break;
				case 2: spin.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 3: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 4: setAutoSize(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 5: setParentColor(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 6: spin.setValue(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 7: spin.setMinimum(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 8: spin.setMaximum(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 9: spin.setStep(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 10: spin.setDelay(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 11: spin.setRate(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 12: spin.setBorderColor(XColorPropertyType.loadFromStream(stream)); break;
				case 13: spin.setBorderWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 14: spin.setOrientation(XBooleanPropertyType.loadBFromStream(stream)); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XColorPropertyType.saveToStream(spin.getBackground(), stream); break;
					case 1: XColorPropertyType.saveToStream(spin.getForeground(), stream); break;
					case 2: XBooleanPropertyType.saveToStream(spin.isEnabled(), stream); break;
					case 3: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 4: XBooleanPropertyType.saveToStream(autoSize, stream); break;
					case 5: XBooleanPropertyType.saveToStream(parentColor, stream); break;
					case 6: XIntegerPropertyType.saveToStream(new Integer(spin.getValue()), stream); break;
					case 7: XIntegerPropertyType.saveToStream(new Integer(spin.getMinimum()), stream); break;
					case 8: XIntegerPropertyType.saveToStream(new Integer(spin.getMaximum()), stream); break;
					case 9: XIntegerPropertyType.saveToStream(new Integer(spin.getStep()), stream); break;
					case 10: XIntegerPropertyType.saveToStream(new Integer(spin.getDelay()), stream); break;
					case 11: XIntegerPropertyType.saveToStream(new Integer(spin.getRate()), stream); break;
					case 12: XColorPropertyType.saveToStream(spin.getBorderColor(), stream); break;
					case 13: XIntegerPropertyType.saveToStream(new Integer(spin.getBorderWidth()), stream); break;
					case 14: XBooleanPropertyType.saveToStream(spin.getOrientation(), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}