/**
* Xelfi
*/

package xelfi.design.forms;

import java.io.*;
import java.util.NoSuchElementException;
import xelfi.top.TopLevel;
import xelfi.editor.Source;
import xelfi.editor.XelfiFile;
import xelfi.templates.*;
import xelfi.util.Debug;

/**
* File manager, when asked loads new form from file.
*
* @version 	1.07, 06 Apr 1997
* @author 		Ian Formanek, Jaroslav Tulach
*/

public class FileFormsManager extends FormsManager {
	/** Returns design form for this manager.
	* @param t the template to generate from
	* @param s the source to generate in
	* @return the application form
	*/
	public XelfiDesignForm getDesignForm (Template t, Source s) 
		throws IOException
	{
		File file = fileForTemplate (t);

		// this can throw IOException if the form does not load properly
		XelfiDesignForm form = XFFormLoader.loadForm(file.toString(), s, s.getFile().getName());
		form.getSource().markModified();
		form.setTemplateName(t.getName());
		return form;
	}
}