/**
* Xelfi
*/

package xelfi.design.util;

/**
 * XFDesignConstants class is a placeholder for different helper 
 * constants for design classes.
 * All the methods are static, so it is not necessary to make 
 * instances of this class.
 *
 * @version 	1.15, 25 Mar 1997
 * @author 	Ian Formanek, Dafe Simonek, Pida Hamernik
 */

public class XFDesignConstants {

/////////
// Ian //
/////////

	/**
	* This variable identifies current version of Xelfi design technology.
	*/
	public final static VersionInfo DESIGN_VERSION = new VersionInfo(0,90,0);
	
	// constants for design/real mode
	public final static int DM_DESIGN = 0;
	public final static int DM_REAL = 1;

	// constants for form types
	public final static int FT_NOFORM = 0;
	public final static int FT_APPLICATION = 1;
	public final static int FT_FRAME = 2;
	public final static int FT_DIALOG = 3;
	public final static int FT_APPLET = 4;

	// constants for selection/add mode
	public final static int XM_SELECTIONMODE = 0;
	public final static int XM_ADDMODE = 1;

	// constants for code generation for Forms
	public final static int FGEN_SOURCE_BEGIN = 1;
	public final static int FGEN_IMPORTS = 2;
	public final static int FGEN_CLASS_BEGIN = 4;
	public final static int FGEN_CONSTRUCTOR_BEGIN = 8;
	public final static int FGEN_CONSTRUCTOR_END = 16;
	public final static int FGEN_HANDLE_BEGIN = 32;
	public final static int FGEN_HANDLE_DEFBODY = 64;
	public final static int FGEN_HANDLE_END = 128;
	public final static int FGEN_MAIN_BEGIN = 512;
	public final static int FGEN_MAIN_DEFBODY = 1024;
	public final static int FGEN_MAIN_END = 2048;
	public final static int FGEN_VARIABLES = 4096;
	public final static int FGEN_CLASS_END = 8192;
	public final static int FGEN_SOURCE_END = 16384;

	public final static int FGEN_FORM_LAYOUT = 65536;
	public final static int FGEN_FORM_SETPROPS = 131072;
	public final static int FGEN_FORM_RESIZE = 262144;

	// constants for code generation for components
	public final static int GEN_VARIABLE = 1;
	public final static int GEN_INIT = 2;
	public final static int GEN_SETPROPS = 4;
	public final static int GEN_RESHAPE = 8;
	public final static int GEN_ADD = 16;
	public final static int GEN_SETLAYOUT = 32;

	public final static int GEN_ALL = 63;

	// constants for form init state
	public final static int IS_NORMAL = 1;
	public final static int IS_ICONIFIED = 2;
	public final static int IS_MAXIMIZED = 3; // not supported ???
	
	public static String initStateString(int is) {
		switch (is) {
			case IS_NORMAL: return "Normal";
			case IS_ICONIFIED: return "Iconified";
			default: return null;
		}
	}
	
//////////
// Dafe //
//////////

	// constants for component inspector
	// page constants
	public final static int CI_PG_PROPERTIES = 1;
	public final static int CI_PG_EVENTS = 2;
	public final static int CI_PG_LAYOUT = 3;

	// constants for viewer types
	public final static int PVT_READONLY = 0;
	public final static int PVT_CHECK = 1;
	public final static int PVT_INPUT_INT = 2;
	public final static int PVT_INPUT_FLOAT = 3;
	public final static int PVT_INPUT_STRING = 4;
	public final static int PVT_CHOICE_STRICT = 5;
	public final static int PVT_CHOICE_FREE = 6;
	public final static int PVT_INPUT_CHAR = 7;

	public final static int PVT_SPECIAL = 128;

//////////
// Pida //
//////////

	// return constants of setProperty method
	public final static int RSP_OK = 0;			// Property changed OK
	public final static int RSP_PARENT_UPDATE = 1;	// Subcomponents should be updated
	public final static int RSP_FORM_UPDATE = 2;	// Property influences whole form
	public final static int RSP_DIFF_VALUE = 4;	// Property set to value different than the given one
	public final static int RSP_OTHER_PROP = 8;	// Other properties changed too
	public final static int RSP_REPAINT_COMP = 16;	// Component should be repainted
	public final static int RSP_SHOW_HIDE = 32;	// Component should be hidden and shown again
	public final static int RSP_VALIDATE = 64;	// Component should be validated
	public final static int RSP_VALIDATE_PARENT = 128;	// Component's parent should be validated

	public final static int SEL_UNSELECT = 1;
	public final static int SEL_SELECT = 2;
	public final static int SEL_MUL_SELECT = 3;

}
