/**
* Xelfi Environment
*/

package xelfi.editor;

/** Accepts word.
*
* @author Jaroslav Tulach
* @version 1.0
*/
class AcceptorFind extends Object implements Acceptor {
  /** back function */
  private int[] back;

  /** string to search for */
  String text;

  /** Position in word */
  int pos;

  /** ignore case */
  boolean caseSensitive;

  /**
  * @param s word to seach for
  * @param cs case sensitive
  */
  public AcceptorFind (String s, boolean cs) {
    if (!cs) s = s.toUpperCase ();
    reset (s);
    caseSensitive = cs;
  }

  /** Resets all data.
  * @param s the string to search for
  */
  public void reset (String s) {
    pos = 0;

    if (s.equals (text)) return;

    int len;
    back = new int[len = s.length ()];
    text = s;

    // init back
    back[0] = 0;
    back[1] = 0;
    int p = 0;
    int i = 1;
    while (++i < len) {
      p = back[i] = next (p, text.charAt (i));
    };
  };

  /** Go next.
  * @param indx index
  * @param ch char to go next
  */
  private int next (int indx, char ch) {
    for (;;) {
      // if the char matches go next
      if (text.charAt (indx) == ch) return indx + 1;

      // if we cannot go from first position, stop
      if (indx == 0) return 0;

      // otherwise go back one piece
      indx = back[indx];
    }
  };

  /**
  * should we continue or stop the action?
  * @param ch the character at specified position
  * @return true to stop the search or false to continue
  */
  public boolean accept (char ch) {
    if (!caseSensitive) ch = Character.toUpperCase (ch);
    pos = next (pos, ch);
    return pos == back.length;
  };


}





// Generated from substitution template 'XelfiClass' Blocks:Class:9,28,21,28; Class:6,11,18,11; Package:8,4,20,4; 
