/**
* Xelfi programming environment
*/

package xelfi.editor;
import java.io.IOException;
/**
* Class implementing this interface must be attached to every
* Source. It then handles basic operation with the source.
* The list of operation should extend in future.
*
* @version 1.0
* @author Jaroslav Tulach
*/

public interface DocumentHandler {
  /** This method is called when the source s should be saved.
  * @param s the source
  * @param backup true if a backup should be created
  * @exception IOException if some error occures
  */
  public void saveSource (Source s, boolean backup) throws IOException;

  /** Shows all views for this document.
  * @param s source
  */
  public void showAll (Source s);
};
