/**
* Xelfi Environment
*/

package xelfi.editor;

/** Provides information about changes in the document.
*
* @author Jaroslav Tulach
* @version 1.0
*/
public interface DocumentListener {
  /** This is called when the modified flag of the editor changes.
  * Either turns to modified or unmodified.
  * @param d document
  * @param mod true if the document is now modified
  */
  public void documentModified (Document d, boolean mod);

  /** When someone sends a message to document this method is called.
  * @param d document
  * @param s string
  */
  public void documentMessage (Document d, String s);
}



// Generated from substitution template 'XelfiInterface' Blocks:Class:17,11,33,11; Package:8,4,20,4; 
