/**
* Xelfi programming environment
*/

package xelfi.editor;
/**
* This exception can be thrown from methods insert, delete at a position
* to signal that this action is not allowed.
*
* @version 1.0
* @author Jaroslav Tulach
*/

public class NotAllowedException extends Exception {
  private boolean notify = true;

  /** Constructor.
  */
  public NotAllowedException () {
  };
  
  /** @param s string describing the message */
  public NotAllowedException (String s) {
    super (s);
  };

  /** @param n notify. If true user will be notified that this action is not
  * allowed. False means no notification. The default value is true.
  */
  public NotAllowedException (boolean n) {
    notify = n;
  };

  /** If true users should be notified that this action failed.
  * @return true/false
  */
  public boolean isNotify () {
    return notify;
  };
};


