/**
* Xelfi Environment
*/

package xelfi.editor.keys;
import xelfi.editor.*;
import java.util.Vector;

/** Interace for actions that key happen when key is down.
*
* @author Jarolsav Tulach
* @version 1.0
*/
interface ContextItem {
  /** Accepts the key.
  * Either executes an action and than it should return null to indicate
  * that this is the last key in chain.
  * Or changes key context by returning new key table that will receive
  * key next time
  * @param key the key
  * @param info info about the editor
  * @return the next key table or null if this is the last key in chain
  * @exception NotAllowedException if the action is not allowed
  * @exception EndOfTextException if end of text is reached
  */
  public ContextTable acceptKey (KeyCode key, TextEditorInfo info)
  throws NotAllowedException, EndOfTextException;

  /** Adds new key under this item.
  * @param key the key
  * @param han the handlers to add
  * @return true if ok, false if an error occures
  */
  public boolean addKey (KeyCode key, KeyActionMacro han);
}














// Generated from substitution template 'Interface' Blocks:Class:10,13,21,13; Package:8,4,25,4; 
