package xelfi.editor.keys;
import java.awt.Event;

public class KeyTokenManager implements KeyConstants
{
  protected static final String jjadd_escapes(String str) {
    String retval = "";
    char ch;
    for (int i = 0; i < str.length(); i++) {
      if ((ch = str.charAt(i)) == 0) continue;
      if (ch == '\b') {
        retval += "\\b";
      } else if (ch == '\t') {
        retval += "\\t";
      } else if (ch == '\n') {
        retval += "\\n";
      } else if (ch == '\f') {
        retval += "\\f";
      } else if (ch == '\r') {
        retval += "\\r";
      } else if (ch == '\"') {
        retval += "\\\"";
      } else if (ch == '\'') {
        retval += "\\\'";
      } else if (ch == '\\') {
        retval += "\\\\";
      } else if (ch < 0x20 || ch > 0x7e) {
        String s = "0000" + Integer.toString(ch, 16);
        retval += "\\u" + s.substring(s.length() - 4, s.length());
      } else {
        retval += ch;
      }
    }
    return retval;
  }

static final long[] jjbitVec0 = { 0x1L, 0x0L,
              0xffffffffffffffffL, 0xffffffffffffffffL };
static private final void jjMoveNfa_0(int[] oldStates, int[] newStates)
{
   int j, k;
   MainLoop :
   for (;;)
   {
      if (curChar < 64)
      {
         int i = jjnewStateCnt;
         jjnewStateCnt = 0;
         jjround++;
         long l = 1L << curChar;
         do
         {
            switch(oldStates[--i])
            {
               case (0) :
                  if ((0xfffffffeffffd9ffL & l) != 0L)
                  {
                     if (jjcurKind > 9)
                        jjcurKind = 9;
                     return;
                  }
                  else continue;
               default : continue;
            }
         } while(i != 0);
      }
      else if (curChar < 128)
      {
         int i = jjnewStateCnt;
         jjnewStateCnt = 0;
         jjround++;
         long l = 1L << (curChar & 077);
         do
         {
            switch(oldStates[--i])
            {
               case (0) :
                     if (jjcurKind > 9)
                        jjcurKind = 9;
                     return;
               default : continue;
            }
         } while(i != 0);
      }
      else
      {
         int i = jjnewStateCnt;
         jjnewStateCnt = 0;
         jjround++;
         int i2 = (curChar & 0xff) >> 6;
         int i1 = ((curChar >> 8) & 0xff) >> 6;
         long l2 = 1L << (curChar & 077);
         long l1 = 1L << ((curChar >> 8) & 077);
         Outer:
         do
         {
            switch(oldStates[--i])
            {
               case (0) :
                  MatchLoop:
                  for(;;)
                  {
                     switch((curChar >> 8))
                     {
                        case (0):
                           if ((jjbitVec0[i2] & l2) == 0L)
                              continue Outer;
                           break MatchLoop;
                        default : break;
                     }
                     continue Outer;
                  }
                  if (jjcurKind > 9)
                     jjcurKind = 9;
                  continue;
               default : continue;
            }
         } while(i != 0);
      }
      return;
   }
}
static void jjStartNfa_0(int pos, long active0)
{
   switch (pos)
   {
      case (0) : 
         curPos = 1;
         break; 
      case (1) :
         curPos = 2;
         if ((active0 & 0xfff7ffc00L) != 0L)
         {
            matchedToken.kind = 9;
            jjstartStateSet = jjstates0;
            break;
         }
         return;
      case (2) :
         curPos = 3;
         if ((active0 & 0xfff7ffc00L) != 0L)
         {
            if (jjmatchedPos == 0)
            {
               matchedToken.kind = 9;
               jjmatchedPos = 0;
            }
            jjstartStateSet = jjstates0;
            break;
         }
         return;
      case (3) :
         curPos = 4;
         if ((active0 & 0xe007f7c00L) != 0L)
         {
            if (jjmatchedPos == 0)
            {
               matchedToken.kind = 9;
               jjmatchedPos = 0;
            }
            jjstartStateSet = jjstates0;
            break;
         }
         return;
      case (4) :
         curPos = 5;
         if ((active0 & 0x4b7400L) != 0L)
         {
            if (jjmatchedPos == 0)
            {
               matchedToken.kind = 9;
               jjmatchedPos = 0;
            }
            jjstartStateSet = jjstates0;
            break;
         }
         return;
      case (5) :
         curPos = 6;
         if ((active0 & 0x482000L) != 0L)
         {
            if (jjmatchedPos == 0)
            {
               matchedToken.kind = 9;
               jjmatchedPos = 0;
            }
            jjstartStateSet = jjstates0;
            break;
         }
         return;
      default : 
         curPos = pos + 1;
         return;
   }
   if (jjstartStateSet != null)
   {
      jjnewStateCnt = jjstartStateSet.length;
      jjMoveNfa_0(jjstartStateSet, jjstateSet2);
      if (jjcurKind != 2147483647)
      {
         if (jjmatchedPos != pos)
         {
            matchedToken.kind = jjcurKind;
            jjmatchedPos = pos;
         }
         else if (jjcurKind < matchedToken.kind)
            matchedToken.kind = jjcurKind;
         jjcurKind = 2147483647;
      }
   }
   return;
}
static long jjnewActive_00 = 0L, jjoldActive_00 = 0L;
static private final void jjMoveStringLiteralDfa0_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
         switch(curChar)
         {
            case (68) : 
            case (100) : 
              jjoldActive_00 = 0x204000L;
               break;
            case (67) : 
            case (99) : 
               matchedToken.kind = 7;
               break ReturnLoop;
            case (66) : 
            case (98) : 
              jjoldActive_00 = 0x400000L;
               break;
            case (65) : 
            case (97) : 
               matchedToken.kind = 8;
               break ReturnLoop;
            case (95) : 
               matchedToken.kind = 1;
               break ReturnLoop;
            case (93) : 
               matchedToken.kind = 5;
               break ReturnLoop;
            case (91) : 
               matchedToken.kind = 4;
               break ReturnLoop;
            case (45) : 
               matchedToken.kind = 3;
               break ReturnLoop;
            case (43) : 
               matchedToken.kind = 2;
               break ReturnLoop;
            case (85) : 
            case (117) : 
              jjoldActive_00 = 0x8000L;
               break;
            case (84) : 
            case (116) : 
              jjoldActive_00 = 0x40000L;
               break;
            case (83) : 
            case (115) : 
               matchedToken.kind = 6;
              jjoldActive_00 = 0x800000L;
               break;
            case (82) : 
            case (114) : 
              jjoldActive_00 = 0x2000L;
               break;
            case (80) : 
            case (112) : 
              jjoldActive_00 = 0x30000L;
               break;
            case (76) : 
            case (108) : 
              jjoldActive_00 = 0x1000L;
               break;
            case (72) : 
            case (104) : 
              jjoldActive_00 = 0x400L;
               break;
            case (70) : 
            case (102) : 
              jjoldActive_00 = 0xfff000000L;
               break;
            case (69) : 
            case (101) : 
              jjoldActive_00 = 0x180800L;
               break;
            default : 
               if (curChar < 128)
               {
                  if ((jjstartStateSet = jjinitStates_0[curChar]) == null)
                  {
                     curPos = 1;
                     return;
                  }
               }
               else 
                  jjstartStateSet = jjallInitStates_0;
               jjStartNfa_0(0, 0L);
               return;
         }
         jjMoveStringLiteralDfa1_0();
         return;
    }
   }
   curPos = 1;
   return;
}
static private final void jjMoveStringLiteralDfa1_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (65) : 
            case (97) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x440000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (57) : 
               if ((jjoldActive_00 & 0x100000000L) != 0L)
               {
                  matchedToken.kind = 32;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (56) : 
               if ((jjoldActive_00 & 0x80000000L) != 0L)
               {
                  matchedToken.kind = 31;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (55) : 
               if ((jjoldActive_00 & 0x40000000L) != 0L)
               {
                  matchedToken.kind = 30;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (54) : 
               if ((jjoldActive_00 & 0x20000000L) != 0L)
               {
                  matchedToken.kind = 29;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (53) : 
               if ((jjoldActive_00 & 0x10000000L) != 0L)
               {
                  matchedToken.kind = 28;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (52) : 
               if ((jjoldActive_00 & 0x8000000L) != 0L)
               {
                  matchedToken.kind = 27;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (51) : 
               if ((jjoldActive_00 & 0x4000000L) != 0L)
               {
                  matchedToken.kind = 26;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (50) : 
               if ((jjoldActive_00 & 0x2000000L) != 0L)
               {
                  matchedToken.kind = 25;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (49) : 
               if ((jjoldActive_00 & 0x1000000L) != 0L)
               {
                  matchedToken.kind = 24;
                  jjmatchedPos = 1;
                  }
              if (((jjnewActive_00 = jjoldActive_00 & 0xe00000000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (83) : 
            case (115) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x100000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (80) : 
            case (112) : 
               if ((jjoldActive_00 & 0x8000L) != 0L)
               {
                  matchedToken.kind = 15;
                  break ReturnLoop;
                  }
              if (((jjnewActive_00 = jjoldActive_00 & 0x800000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (79) : 
            case (111) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x4400L)) == 0L)
                 break StartNfaLoop;
               break;
            case (78) : 
            case (110) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x80800L)) == 0L)
                 break StartNfaLoop;
               break;
            case (73) : 
            case (105) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x2000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (71) : 
            case (103) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x30000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (69) : 
            case (101) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x201000L)) == 0L)
                 break StartNfaLoop;
               break;
            default : 
               jjStartNfa_0(1, jjoldActive_00); 
               return;
         }
         jjMoveStringLiteralDfa2_0();
         return;
}
   jjStartNfa_0(1, jjoldActive_00); 
   return;
} catch(java.io.IOException e) {
   if (curChar < 128)
   {
      if ((jjstartStateSet = jjinitStates_0[curChar]) == null)
      {
         curPos = 2;
         return;
      }
   }
   else 
      jjstartStateSet = jjallInitStates_0;
   jjStartNfa_0(0, 0L);
   return;
}
    }
   }
   jjmatchedPos = 1;
   curPos = 2;
   return;
}
static private final void jjMoveStringLiteralDfa2_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (68) : 
            case (100) : 
               if ((jjnewActive_00 & 0x800L) != 0L)
               {
                  matchedToken.kind = 11;
                  break ReturnLoop;
                  }
              if (((jjoldActive_00 = jjnewActive_00 & 0x20000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (67) : 
            case (99) : 
               if ((jjnewActive_00 & 0x100000L) != 0L)
               {
                  matchedToken.kind = 20;
                  break ReturnLoop;
                  }
              if (((jjoldActive_00 = jjnewActive_00 & 0x400000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (66) : 
            case (98) : 
               if ((jjnewActive_00 & 0x40000L) != 0L)
               {
                  matchedToken.kind = 18;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (65) : 
            case (97) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x800000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (50) : 
               if ((jjnewActive_00 & 0x800000000L) != 0L)
               {
                  matchedToken.kind = 35;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (49) : 
               if ((jjnewActive_00 & 0x400000000L) != 0L)
               {
                  matchedToken.kind = 34;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (48) : 
               if ((jjnewActive_00 & 0x200000000L) != 0L)
               {
                  matchedToken.kind = 33;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (87) : 
            case (119) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x4000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (85) : 
            case (117) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x10000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (84) : 
            case (116) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x80000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (77) : 
            case (109) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x400L)) == 0L)
                 break StartNfaLoop;
               break;
            case (76) : 
            case (108) : 
               if ((jjnewActive_00 & 0x200000L) != 0L)
               {
                  matchedToken.kind = 21;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (71) : 
            case (103) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x2000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (70) : 
            case (102) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x1000L)) == 0L)
                 break StartNfaLoop;
               break;
            default : 
               jjStartNfa_0(2, jjnewActive_00); 
               return;
         }
         jjMoveStringLiteralDfa3_0();
         return;
}
   jjStartNfa_0(2, jjnewActive_00); 
   return;
} catch(java.io.IOException e) {
   jjStartNfa_0(1, jjoldActive_00); 
   return;
}
    }
   }
   jjmatchedPos = 2;
   curPos = 3;
   return;
}
static private final void jjMoveStringLiteralDfa3_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (67) : 
            case (99) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x800000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (84) : 
            case (116) : 
               if ((jjoldActive_00 & 0x1000L) != 0L)
               {
                  matchedToken.kind = 12;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (80) : 
            case (112) : 
               if ((jjoldActive_00 & 0x10000L) != 0L)
               {
                  matchedToken.kind = 16;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (78) : 
            case (110) : 
               if ((jjoldActive_00 & 0x4000L) != 0L)
               {
                  matchedToken.kind = 14;
                  break ReturnLoop;
                  }
               else if ((jjoldActive_00 & 0x20000L) != 0L)
               {
                  matchedToken.kind = 17;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (75) : 
            case (107) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x400000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (72) : 
            case (104) : 
              if (((jjnewActive_00 = jjoldActive_00 & 0x2000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (69) : 
            case (101) : 
               if ((jjoldActive_00 & 0x400L) != 0L)
               {
                  matchedToken.kind = 10;
                  break ReturnLoop;
                  }
              if (((jjnewActive_00 = jjoldActive_00 & 0x80000L)) == 0L)
                 break StartNfaLoop;
               break;
            default : 
               jjStartNfa_0(3, jjoldActive_00); 
               return;
         }
         jjMoveStringLiteralDfa4_0();
         return;
}
   jjStartNfa_0(3, jjoldActive_00); 
   return;
} catch(java.io.IOException e) {
   jjStartNfa_0(2, jjnewActive_00); 
   return;
}
    }
   }
   jjmatchedPos = 3;
   curPos = 4;
   return;
}
static private final void jjMoveStringLiteralDfa4_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (84) : 
            case (116) : 
               if ((jjnewActive_00 & 0x2000L) != 0L)
               {
                  matchedToken.kind = 13;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (83) : 
            case (115) : 
              if (((jjoldActive_00 = jjnewActive_00 & 0x400000L)) == 0L)
                 break StartNfaLoop;
               break;
            case (82) : 
            case (114) : 
               if ((jjnewActive_00 & 0x80000L) != 0L)
               {
                  matchedToken.kind = 19;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            case (69) : 
            case (101) : 
               if ((jjnewActive_00 & 0x800000L) != 0L)
               {
                  matchedToken.kind = 23;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            default : 
               jjStartNfa_0(4, jjnewActive_00); 
               return;
         }
         jjMoveStringLiteralDfa5_0();
         return;
}
   jjStartNfa_0(4, jjnewActive_00); 
   return;
} catch(java.io.IOException e) {
   jjStartNfa_0(3, jjoldActive_00); 
   return;
}
    }
   }
   jjmatchedPos = 4;
   curPos = 5;
   return;
}
static private final void jjMoveStringLiteralDfa5_0() throws java.io.IOException
{
   ReturnLoop:
   for (;;)
   {
    MainLoop:
    for (;;)
    {
     try
     {
      StartNfaLoop:
      for (;;)
      { 
         switch(curChar = input_stream.readChar())
         {
            case (80) : 
            case (112) : 
               if ((jjoldActive_00 & 0x400000L) != 0L)
               {
                  matchedToken.kind = 22;
                  break ReturnLoop;
                  }
            break StartNfaLoop;
            default : 
               jjStartNfa_0(5, jjoldActive_00); 
               return;
         }
}
   jjStartNfa_0(5, jjoldActive_00); 
   return;
} catch(java.io.IOException e) {
   jjStartNfa_0(4, jjnewActive_00); 
   return;
}
    }
   }
   jjmatchedPos = 5;
   curPos = 6;
   return;
}
static final int[] jjallInitStates_0 = { 0, };
static final int[] jjstates0 = null;
static final int[][] jjinitStates_0 = {
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, null, null, 
jjallInitStates_0, jjallInitStates_0, null, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, null, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, jjallInitStates_0, 
jjallInitStates_0, jjallInitStates_0, };

public static final String[] jjstrLiteralImages = {
null, "\137", "\53", "\55", "\133", "\135", null, null, null, null, null, null, 
null, null, null, null, null, null, null, null, null, null, null, null, null, null, 
null, null, null, null, null, null, null, null, null, null, };
public static final String[] lexStateNames = {
   "DEFAULT", 
};
static private ASCII_CharStream input_stream;
static private int[] jjrounds = new int[1];
static private int[] jjstateSet1 = new int[1];
static private int[] jjstateSet2 = new int[1];
static private int[] jjnextStates;
static int curPos;
static protected char curChar;
static int jjcurKind = 2147483647;
static KeyTokenManager jjme;
public KeyTokenManager(ASCII_CharStream stream)
{
if (input_stream != null)
{
   System.err.println("ERROR: Second call to constructor of static lexer.  You must");
   System.err.println("       either use ReInit() or set the JavaCC option STATIC to false");
   System.err.println("       during lexer generation.");
   throw new Error();
}
input_stream = stream;
jjme = this;
}
public KeyTokenManager(ASCII_CharStream stream, int lexState)
{
if (input_stream != null)
{
   System.err.println("ERROR: Second call to constructor of static lexer.  You must");
   System.err.println("       either use ReInit() or set the JavaCC option STATIC to false");
   System.err.println("       during lexer generation.");
   throw new Error();
}
input_stream = stream;
jjme = this;
   if (lexState >= 1 || lexState < 0)
   {
      System.out.println("Error: Ignoring invalid lexical state : " + lexState + ". Starting lexer in DEFAULT state.");
      curLexState = defaultLexState;
   }
   else
      curLexState = lexState;
}
static public void ReInit(ASCII_CharStream stream)
{
int i;
jjcurKind = 2147483647;
curPos = jjmatchedPos = jjnewStateCnt = jjround = 0;
jjstartStateSet = null;
curChar = (char)0;
jjEOFSeen = false;
curLexState = defaultLexState;
input_stream = stream;
for (i = 1; i-- > 0;)
   jjrounds[i] = 0;
}
static public void ReInit(ASCII_CharStream stream, int lexState)
{
int i;
jjcurKind = 2147483647;
curPos = jjmatchedPos = jjnewStateCnt = jjround = 0;
jjstartStateSet = null;
curChar = (char)0;
jjEOFSeen = false;
   if (lexState >= 1 || lexState < 0)
   {
      System.out.println("Error: Ignoring invalid lexical state : " + lexState + ". Reinitialzing lexer in DEFAULT state.");
      curLexState = defaultLexState;
   }
   else
      curLexState = lexState;
input_stream = stream;
for (i = 1; i-- > 0;)
   jjrounds[i] = 0;
}
static public void SwitchTo(int lexState)
{
   if (lexState >= 1 || lexState < 0)
      System.out.println("Error: Ignoring invalid lexical state : " + lexState + ". State unchanged.");
   else
      curLexState = lexState;
}


static int curLexState = 0;
static int defaultLexState = 0;
static int jjnewStateCnt;
static int jjround;
static private boolean jjEOFSeen = false;
static int[] jjtmpStates = jjstateSet1;
static int jjmatchedPos;
static Token matchedToken;
static Token jjspecialToken;
static private int[] jjstartStateSet;

static public Token getNextToken() throws ParseError
{
  matchedToken = new Token();

  EOFLoop : for (;;)
  {   
   try   
   {     
      curChar = input_stream.BeginToken();
   }     
   catch(java.io.IOException e)
   {        
      matchedToken.endLine = matchedToken.beginLine = input_stream.getBeginLine();
      matchedToken.endColumn = matchedToken.beginColumn = input_stream.getBeginColumn();
      matchedToken.kind = 0;
      matchedToken.image = "";
      return matchedToken;
   }

   try
   {
    for (;;)
    {
      matchedToken.kind = 2147483647;
      jjmatchedPos = 0;
      jjMoveStringLiteralDfa0_0();
      while (jjnewStateCnt != 0)
      {
         curChar = input_stream.readChar();
         jjMoveNfa_0(jjstateSet1 = jjstateSet2, jjstateSet2 = jjtmpStates);
         jjtmpStates = jjstateSet1;
         if (jjcurKind != 2147483647)
         {
            matchedToken.kind = jjcurKind;
            jjcurKind = 2147483647;
            jjmatchedPos = curPos++;
         }
         else
            curPos++;
      }

      if (matchedToken.kind != 2147483647)
      {
         if (jjmatchedPos + 1 < curPos)
            input_stream.backup(curPos - jjmatchedPos - 1);

            if ((matchedToken.image = jjstrLiteralImages[matchedToken.kind]) == null)
               matchedToken.image = input_stream.GetImage();
            matchedToken.beginLine = input_stream.getBeginLine();
            matchedToken.beginColumn = input_stream.getBeginColumn();
            matchedToken.endLine = input_stream.getEndLine();
            matchedToken.endColumn = input_stream.getEndColumn();
            return matchedToken;
      }
      else
      {
         jjme.error_line = input_stream.getEndLine();
         jjme.error_column = input_stream.getEndColumn();
         input_stream.backup(1);
         jjme.error_after = curPos <= 1 ? "" : jjadd_escapes(input_stream.GetImage());
         jjme.LexicalError();

         throw new ParseError();
      }
    }
   }
   catch (java.io.IOException e)
   {
      switch(curLexState)
      {
         default : break;
      }
      if (matchedToken.kind != 2147483647 && matchedToken.kind != 0)
      {
         if (jjmatchedPos + 1 < curPos)
            input_stream.backup(curPos - jjmatchedPos - 1);

            if ((matchedToken.image = jjstrLiteralImages[matchedToken.kind]) == null)
               matchedToken.image = input_stream.GetImage();
            matchedToken.beginLine = input_stream.getBeginLine();
            matchedToken.beginColumn = input_stream.getBeginColumn();
            matchedToken.endLine = input_stream.getEndLine();
            matchedToken.endColumn = input_stream.getEndColumn();
            return matchedToken;
      }

      jjme.error_line = input_stream.getEndLine();
      jjme.error_column = input_stream.getEndColumn();
      input_stream.backup(1);
      jjEOFSeen = true;
      jjme.error_after = curPos <= 1 ? "" : jjadd_escapes(input_stream.GetImage());
      jjme.LexicalError();

      throw new ParseError();
   }
  }
}

protected int error_line, error_column;
protected String error_after;
protected void LexicalError()
{
   System.err.println("Lexical error at line " +
        error_line + ", column " +
        error_column + ".  Encountered: " +
        (jjEOFSeen ? "<EOF>" : ("\"" + jjadd_escapes(String.valueOf(curChar)) + "\"") + " (" + (int)curChar + "), ") +
        "after : \"" + jjme.error_after + "\"");
}
}
