package xelfi.execution;

import java.awt.*;
import java.io.*;

public class PipedInputLine extends TextField
{
  OutputStream out;
  public PipedInputLine(OutputStream o)
  {
    super();
    out = o;
  }

  public PipedInputLine(int size, OutputStream o)
  {
    super(size);
    out = o;
  }

  public boolean keyDown(Event ev, int key)
  {
    if(key == '\n')
    {
      String val = getText();
      int len = val.length();
      byte bytes[] = new byte [len];
      val.getBytes(0, len, bytes, 0);
      try
      {
        out.write(bytes);
        out.write((int)'\n');
        out.flush();
      }
      catch(IOException ex) { System.err.println(ex.toString()); }
      setText("");
      return true;
    }
    else return super.keyDown(ev, key);
  }
}


