/**
* Xelfi programming environment
*/

package xelfi.templates;
import xelfi.awt.XFTreeViewPanel;
import java.awt.Dimension;
/**
* This class lets you view and select from
* all templates in the system.
*
* @version $Id$
* @autor Jaroslav Tulach
*/

public class TemplateView extends XFTreeViewPanel {
  /** Constructs new view.
  */
  public TemplateView () {
    super (Template.getTree ().getRoot ().getData ());
    setTree (Template.getTree ());
  };

  /** Returns currently selected template.
  * @return the template
  */
  public Template getCurrent () {
    return (Template)(getTreeViewCanvas ().getTreeView ().getCurNode ().getData ());
  };

  /** Sets new selected template.
  * @param t the template to make selected
  */
  public void setCurrent (Template t) {
    getTreeViewCanvas ().getTreeView ().selectAbsNode (t.treeNode);
  };

  /** Returns the preffered size
  * @return the dimension
  */
  public Dimension preferredSize () {
    Dimension d = super.preferredSize ();
    if (d.height > 150) d.height = 150;
    return d;
  };

  /** Returns the minimum size
  * @return the dimension
  */
  public Dimension minimalSize () {
    Dimension d = super.minimumSize ();
    if (d.height > 80) d.height = 80;
    return d;
  };
};








