/**
* Xelfi
*/

package xelfi.top.toolbar;

/**
  *
  * @version 	1.00, 12 Jan 1997
  * @author 	Petr Hamernik
  *
  */

import java.util.Vector;

public class XFToolbarEntry {
	public final static boolean TBE_BUTTON = true;
	public final static boolean TBE_SEPARATOR = false;
	
	private boolean type = TBE_SEPARATOR;
	private int action;
	private String icon;
	
	public XFToolbarEntry() {
		type = TBE_SEPARATOR;
		icon = null;
		action = 0;
	}
	
	public XFToolbarEntry(int aAction) {
		type = TBE_BUTTON;
		action = aAction + XFToolbarConstants.TRANS;
		icon = XFToolbarConstants.getIconName(action);
	}
	
	public boolean getType() {
		return type;
	}
	
	public String getIcon() {
		return icon;
	}

	public int getAction() {
		return action;
	}
	
	public boolean isSeparator() {
		return (type == TBE_SEPARATOR);
	}

	public boolean isButton() {
		return (type != TBE_SEPARATOR);
	}
}